/*----------------------------------------------------------------------*\

	pmParse.c

	ParserMaker generated parser

\*----------------------------------------------------------------------*/

/* %%IMPORT */


#include "util.h"
#include "../interpreter/acode.h"

#include "types.h"
#include "smScan.h"
#include "token.h"

#include "lmList.h"

#include "alt.h"
#include "evt.h"
#include "lim.h"
#include "msg.h"
#include "opt.h"
#include "sco.h"
#include "str.h"
#include "syn.h"
#include "adv_x.h"
#include "add_x.h"
#include "article_x.h"
#include "atr_x.h"
#include "cla_x.h"
#include "chk_x.h"
#include "cnt_x.h"
#include "elm_x.h"
#include "exp_x.h"
#include "ext_x.h"
#include "id_x.h"
#include "ins_x.h"
#include "description_x.h"
#include "initialize_x.h"
#include "resource_x.h"
#include "rul_x.h"
#include "lst_x.h"
#include "prop_x.h"
#include "res_x.h"
#include "scr_x.h"
#include "stm_x.h"
#include "stp_x.h"
#include "stx_x.h"
#include "sym_x.h"
#include "vrb_x.h"
#include "whr_x.h"
#include "wht_x.h"

/* END %%IMPORT */

#include <string.h>
#include <setjmp.h>

#include "pmParse.h"

#define PMTRUE 1
#define PMFALSE 0
typedef unsigned char PmBoolean; /* For logical values */

/* System dependencies */

/* These datatypes should be defined to be unsigned integers of length 1, 2
 * and 4 bytes respectively.
 */
typedef unsigned char UByte1;
typedef unsigned short UByte2;
typedef unsigned int UByte4;

/* Token definition */
#include "alanCommon.h"

/* %%ATTRIBUTES - The semantic attributes for grammar symbols */
typedef struct pmGrammar {
    Bool wordOrChar;
    What *wht;
    Where *whr;
    List *vrbs;
    Verb *vrb;
    int val;
    List *syns;
    Synonym *syn;
    List *stxs;
    Syntax *stx;
    char *str;
    List *stps;
    Step *stp;
    List *stms3;
    List *stms2;
    List *stms;
    Statement *stm;
    Srcp srcp2;
    Srcp srcp;
    List *set;
    List *scrs;
    Script *scr;
    SayForm sayForm;
    List *ruls;
    RulNod *rul;
    RestrictionKind restrictionKind;
    List *ress;
    Restriction *res;
    QualKind qual;
    Srcp pronounsSrcp;
    List *pronouns;
    Bool present;
    Bool opaque;
    OperatorKind op;
    Article *negative;
    List *nams;
    List *nam;
    List *msgs;
    Message *msg;
    Bool minus;
    Srcp mentionedSrcp;
    List *mentioned;
    List *lims;
    LimNod *lim;
    Bool isForm;
    List *inss;
    Instance *ins;
    Article *indefinite;
    List *idList2;
    List *idList;
    IdNode *id;
    List *form;
    Bool first;
    List *exts;
    Exit *ext;
    List *exps;
    Expression *exp;
    List *evts;
    Event *evt;
    Initialize *initialize;
    Srcp enteredSrcp;
    List *entered;
    List *elms;
    Element *elm;
    Srcp descriptionSrcp;
    List *descriptionDoes;
    List *descriptionChecks;
    Srcp descriptionCheckSrcp;
    Description *description;
    Srcp definiteSrcp;
    Bool definiteIsForm;
    Article *definite;
    List *cnts;
    Container *cnt;
    List *clas;
    Class *cla;
    List *chks;
    ChkNod *chk;
    List *cases;
    int bits;
    List *atrs;
    Attribute *atr;
    Article *article;
    List *alts;
    Alternative *alt;
    AggregateKind agr;
    AddNode *add;
} pmGrammar;

/* END %%ATTRIBUTES */

/* Parser constants *\
\* ---------------- */
#define ERROR_ACT 0			/* Action - Error */
#define SHIFT_ACT 1			/* Action - Shift */
#define SHIFTRED_ACT 2		/* Action - Shift_Reduce */
#define REDUCE_ACT 3		/* Action - Reduce */
#define ACCEPT_ACT 4		/* Action - Accept */

#define ERR_SYM 0		/* Error token */
#define ENDMARK 1		/* End of file token code */

/* Recovery method *\
\* --------------- */
#define NONE_REC 0		/* No recovery found */
#define IN_REC 1		/* Insertion of symbol(s) */
#define DEL_REC 2		/* Deletion of symbol(s) */
#define REP_REC 3		/* Replacement of symbol(s) */
#define BAK_REC 4		/* Stack backup */
#define HALT_REC 5		/* System halted */

/* Error class *\
\* ----------- */
#define LEX_ERR 1		/* Non valid scanner symbol found */
#define SYN_ERR 2		/* Normal syntax error */
#define OFLW_ERR 3		/* Parse stack overflow */
#define TAB_ERR 4		/* Parse table error */
	   
/* Error severity *\
\* -------------- */
#define WAR_SEV 1		/* Warnings */
#define ERR_SEV 2		/* Repairable error */
#define FAT_SEV 3		/* Fatal error */
#define SYS_SEV 4		/* System & limit error */

/* Parser constants *\
\* ---------------- */
#define SccMax 143		/* Max scanner code value */
#define TermMin 1		/* Minimum terminal number */
#define Terms 143		/* Number of terminals in grammar */
#define StateMin 1		/* Minimum state number */
#define States 362		/* Number of states */
#define ProdMin 1		/* Minimum production number */
#define Prods 368		/* Number of productions */
#define PmStkMax 64		/* Parse stack size */
#define	PmLaMax 5		/* Look-ahead length */
#define	PmCost 5		/* Shifting cost */

/* Types *\
\* ----- */
typedef unsigned char TermSet[(Terms + TermMin + 7) >> 3]; /* Terminal set */
typedef UByte2 ParseStack[PmStkMax]; /* Parse stack */

/* Terminal table *\
\* -------------- */

typedef struct {
    UByte1 tsym;		/* Normal continuation */
    UByte1 ssym;		/* Separator continuation */
} ContRec;

typedef struct {
    ContRec cont[362];		/* Continuation function */
    TermSet sepa;		/* Separator symbols */
    TermSet fiduc;		/* Fiducial symbols */
    TermSet skip;		/* Symbols to skip */
} RecTab;

typedef struct  {
    UByte2 act[13827];		/* Action table */
    UByte2 actCheck[13836];	/* Row Displacement Check Vector*/
    UByte2 actRix[362];		/* Action row mapping */
    RecTab recover;		/* Error recovery info */
} TermTab;

static TermTab act = {
{4,2539,689,2539,2539,1762,2539,2539,2539,89,2539,2539,2202,2539,2539,2539
,2539,2539,2539,2539,2539,2539,2539,2539,1650,234,2539,2539,2539,2539,2539
,105,2539,2539,2539,2539,2131,2539,2539,2539,2539,2337,2539,2539,2539,2539
,2539,2539,2065,2369,153,2539,2539,1426,2539,2539,2539,1298,2539,2539,2539
,2539,1306,2297,2539,2539,2539,2539,2539,2539,2539,1051,2539,2539,2539,2539
,2539,2539,857,2658,1819,2642,2650,2666,2531,2345,2539,2539,2539,2539,2539
,2539,2539,283,2539,2539,283,2539,89,2377,2539,2539,1057,1482,2539,2539
,2539,1537,2539,2539,105,1419,1218,153,2539,2539,2539,586,2539,2539,2539
,2539,2539,153,57,2539,2539,2539,2539,2539,2539,2539,2539,2539,2539,2539
,2539,2539,242,2539,2539,2539,2539,2571,1490,2571,2571,1211,2571,2571,89
,1969,2571,2571,1225,2571,2571,2571,2571,2571,2571,2571,2571,2571,2571,2571
,1899,2554,2571,2571,2571,2571,2571,2571,2571,2571,2571,2571,1827,2571,2571
,2571,2571,1994,2571,2571,2571,2571,2571,2571,298,1419,153,2571,2571,1746
,2571,2571,2571,89,2571,2571,2571,2571,153,2562,2571,2571,2571,2571,2571
,2571,2571,2002,2571,2571,2571,2571,2571,2571,1322,2658,1819,2642,2650,2666
,2531,2850,2571,2843,2571,2571,2571,2571,2571,1009,2571,2571,1201,2571,1947
,2065,2571,2571,1057,2585,2571,2571,2571,1425,2571,2571,1577,2017,409,153
,2571,2571,2571,1947,2571,2571,2571,2571,2571,1250,2098,2571,2571,2571,2571
,2571,2571,2571,2571,2571,2571,2571,2571,2571,2075,2571,2571,2571,2571,2419
,1465,2419,2419,1971,257,2419,89,259,2419,2419,1449,2419,2419,2419,2419
,2419,2419,2419,2419,2419,2419,2419,1273,2001,153,2419,2419,2419,2419,2419
,2419,2419,2419,2419,1770,2419,2419,2419,2419,1778,2419,2419,2419,2419,2419
,2419,1730,1642,1257,2419,2419,89,2419,2419,2419,1497,2419,2419,2419,2419
,153,643,2419,2419,2419,2419,2419,2419,2419,1265,2419,2419,2419,2419,2419
,2419,2658,643,2642,2650,2666,1729,1859,1930,2419,1866,2419,2419,2419,2419
,2419,643,2419,2419,2083,2419,1754,2017,2419,2419,89,2450,2419,2419,2419
,1874,2419,2419,441,449,2017,1729,2419,2419,2419,369,2419,2419,2419,2419
,2419,153,2497,2419,2419,2419,2419,2419,2419,2419,2419,2419,2419,2419,2419
,2419,2531,2419,2419,2419,2419,2051,2051,547,153,2058,1129,1633,2051,1882
,489,2602,457,2001,1890,1297,985,2051,2051,2409,2051,2114,2051,2051,2051
,89,2001,1738,2051,2051,1801,153,2051,2051,2051,2051,2051,2051,2051,2051
,2051,2051,2051,2051,2051,2051,2051,2051,2051,1673,2553,2610,2051,2051,2051
,2051,2051,2051,2051,2051,2051,2051,1810,2051,1658,2051,2051,2051,2051,2051
,2219,2051,1786,2219,2051,2051,2051,2051,2051,1986,2139,2051,2051,2051,89
,1907,2051,761,153,2051,2051,2051,2051,2219,2051,2051,2051,2051,2051,2442
,2051,2051,2051,330,2051,2051,2051,2051,1361,2051,2051,153,1666,2625,2051
,2051,2051,2051,2051,2051,2051,2051,2051,2051,385,2051,2051,2051,2051,2051
,2051,2051,2051,2051,2051,2051,2051,2219,2051,793,2051,2051,2219,2051,2091
,2091,1794,1674,2091,194,2673,2091,186,2689,1682,2658,89,2642,2650,2666
,2091,2091,2721,2091,2209,2091,2091,2091,2146,2745,833,2091,2091,1802,2154
,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091
,2091,2091,2162,2122,2793,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091
,2403,2091,2257,2091,2091,2091,2091,2091,2170,2091,2178,2434,2091,2106,2091
,2091,2091,1169,2841,2091,2091,2091,2186,1402,2091,673,2194,2091,2091,2091
,2091,1002,2091,2091,2091,2091,2091,913,2091,2091,2091,74,2091,2091,2091
,2091,82,2091,2091,0,0,0,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091
,0,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091,2091,0,2091,0
,2091,2091,0,2091,2635,2635,0,0,2635,89,0,2635,2635,0,2635,2635,2635,2635
,2635,0,2635,2635,2635,2635,2587,0,0,0,2635,0,2635,2635,0,2635,2635,2635
,2635,0,2635,2635,2635,2779,2779,2635,2635,2635,2635,2635,2635,0,0,0,2635
,2635,2065,2635,2635,2635,0,2635,2635,2635,2635,0,0,2635,2635,2635,2635
,2635,2635,2635,0,2635,2635,2635,2635,2635,2635,0,0,0,0,0,2779,2779,0,2635
,531,2635,2635,2635,0,2635,0,2635,0,0,2635,0,0,2635,2779,2779,531,2635,2635
,2635,531,2635,2635,0,0,0,0,2635,2635,2635,0,2635,2635,2635,2635,2635,2779
,0,2635,2635,2635,2635,2635,2635,2635,2635,531,2635,2635,2635,2635,0,2635
,2635,2635,2635,2411,2779,2779,2786,2411,0,2411,2411,2411,2411,2411,0,2411
,0,2411,2411,0,0,0,0,1635,0,0,2411,0,2411,2411,2411,2411,0,1635,2411,2411
,2411,0,2411,2411,1635,1635,1635,1635,2779,0,0,1635,1635,1635,1635,1635
,2411,1635,1635,1635,1635,0,1635,0,2411,2411,1635,1635,1635,0,1635,2786
,0,0,1635,1635,1635,1635,0,2658,0,2642,2650,2666,0,0,0,0,1635,1635,1635
,0,0,0,1635,0,0,1635,0,0,1635,0,0,0,2411,1635,1635,529,1635,1635,0,0,0,0
,1635,1635,1635,0,1635,1635,2411,1635,1635,1291,0,1635,1635,2411,1635,1635
,1635,1635,2411,0,1635,1635,0,1635,595,1635,1635,1291,1635,1291,1291,1291
,0,0,0,1209,1291,0,0,1291,2409,0,0,0,595,1291,1291,0,2779,2779,1291,1291
,129,1113,1201,825,0,0,0,1291,1291,0,609,1634,1291,0,1291,1291,1291,0,1761
,0,1291,1291,545,561,577,0,929,0,0,1291,2098,809,617,625,0,1011,0,0,0,2779
,2779,1291,0,0,593,697,953,1291,0,0,649,1291,0,1291,0,0,1291,1291,0,1291
,1291,721,873,0,681,665,0,0,595,0,1291,1291,1291,1291,745,777,0,633,641
,2779,0,1291,1291,1291,73,889,1033,1089,595,1291,1291,1291,0,1289,2299,1291
,1291,2299,1291,0,2299,2299,2786,2299,2299,2299,2299,2299,0,1026,2299,2299
,2299,0,1761,0,0,2299,0,2299,2299,0,2299,2299,2299,2299,19,0,2299,2299,329
,19,1034,1042,2299,2299,2299,2299,0,0,0,19,0,19,2299,2299,2299,0,0,0,0,2299
,0,0,2299,2299,2299,2299,2299,2299,2299,595,2299,2299,2299,2299,2299,2299
,0,0,19,19,19,0,0,0,0,595,2299,2299,2299,595,2299,0,2299,0,19,0,42,19,0
,0,0,0,2299,2299,2299,0,2299,2299,0,0,34,19,0,2779,2779,1761,2299,2299,2299
,2299,2299,0,19,0,0,2299,2299,2299,2299,2299,2299,0,425,0,2299,2299,409
,2307,0,2299,2307,0,0,2307,2307,0,2307,2307,2307,2307,2307,0,0,2307,2307
,2307,2779,2779,0,0,2307,0,2307,2307,0,2307,2307,2307,2307,0,0,2307,2307
,0,0,0,0,2307,2307,2307,2307,0,0,0,0,0,0,2307,2307,2307,0,0,0,0,2307,0,2779
,2307,2307,2307,2307,2307,2307,2307,0,2307,2307,2307,2307,2307,2307,1026
,0,2763,2763,0,0,0,0,2786,0,2307,2307,2307,0,2307,0,2307,0,0,2770,0,2763
,0,1034,1042,0,2307,2307,2307,0,2307,2307,0,0,0,0,0,0,0,0,2307,2307,2307
,2307,2307,2763,2763,0,0,2307,2307,2307,2307,2307,2307,0,0,0,2307,2307,0
,2259,0,2307,2259,0,0,2259,2658,0,2642,2650,2666,2259,2259,0,0,2259,2259
,2259,0,0,0,0,2259,2763,0,2259,0,2259,2259,2259,2259,0,0,2259,2259,0,0,0
,0,2259,2259,2259,2259,0,0,0,2763,0,0,2259,2259,2259,0,0,0,0,2259,0,0,2259
,2259,2259,2259,2259,2259,2259,0,2259,2259,2259,2259,2259,2259,0,1026,0
,2763,2763,0,0,0,0,0,2259,2259,2259,0,2259,0,2259,0,0,0,2770,0,2763,0,1034
,1042,2259,2259,2259,0,2259,2259,0,0,0,0,0,0,0,0,2259,2259,2259,2259,2259
,0,2763,2763,0,2259,2259,2259,2259,2259,2259,0,0,0,2259,2259,0,2275,0,2259
,2275,0,0,2275,2658,0,2642,2650,2666,2275,2275,0,0,2275,2275,2275,0,0,0
,0,2275,0,2763,2275,0,2275,2275,2275,2275,91,0,2275,2275,0,91,0,0,2275,2275
,2275,2275,0,0,0,91,2763,91,2275,2275,2275,0,0,0,0,2275,0,0,2275,2275,2275
,2275,2275,2275,2275,0,2275,2275,2275,2275,2275,2275,0,0,91,91,91,0,0,0
,0,0,2275,2275,2275,0,2275,0,2275,0,91,0,0,91,0,0,0,0,2275,2275,2275,0,2275
,2275,0,0,0,91,0,0,0,0,2275,2275,2275,2275,2275,0,91,0,0,2275,2275,2275
,2275,2275,2275,0,0,0,2275,2275,0,2283,0,2275,2283,0,0,2283,2658,0,2642
,2650,2666,2283,2283,0,0,2283,2283,2283,0,0,0,0,2283,0,0,2283,0,2283,2283
,2283,2283,2457,0,2283,2283,0,2737,0,0,2283,2283,2283,2283,0,0,0,2425,0
,2513,2283,2283,2283,0,0,0,0,2283,0,0,2283,2283,2283,2283,2283,2283,2283
,0,2283,2283,2283,2283,2283,2283,0,0,1593,2857,41,0,0,0,0,0,2283,2283,2283
,0,2283,0,2283,0,2601,89,0,106,0,0,0,0,2283,2283,2283,0,2283,2283,2779,2779
,0,1553,0,0,0,0,2283,2283,2283,2283,2283,0,2561,0,0,2283,2283,2283,2283
,2283,2283,0,0,0,2283,2283,0,2291,0,2283,2291,0,0,2291,2658,0,2642,2650
,2666,2291,2291,2779,2779,2291,2291,2291,0,0,0,0,2291,0,0,2291,0,2291,2291
,2291,2291,0,0,2291,2291,2587,0,0,0,2291,2291,2291,2291,0,0,0,0,0,0,2291
,2291,2291,0,2779,0,0,2291,0,0,2291,2291,2291,2291,2291,2291,2291,0,2291
,2291,2291,2291,2291,2291,0,0,0,2786,0,0,0,0,0,2682,2291,2291,2291,0,2291
,0,2291,0,2714,2722,0,0,0,2779,2779,0,2291,2291,2291,0,2291,2291,0,0,2674
,2690,2698,2706,0,0,2291,2291,2291,2291,2291,0,0,0,0,2291,2291,2291,2291
,2291,2291,0,0,0,2291,2291,0,0,635,2291,635,635,2779,2779,0,0,1209,0,0,0
,0,0,0,0,0,0,635,0,635,0,0,635,635,129,1113,1201,825,0,0,0,635,635,635,609
,1634,0,635,635,635,635,0,635,2779,635,635,545,561,577,0,929,0,0,0,2098
,809,617,625,0,513,0,0,0,0,0,0,2786,0,593,697,953,497,0,0,649,0,0,635,0
,0,635,0,0,0,635,721,873,0,681,665,0,0,0,0,635,635,635,0,745,777,0,633,641
,0,0,635,635,635,73,889,1033,1089,0,0,635,635,0,1289,0,635,635,603,635,603
,603,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,603,0,0,0,0,603,603,129,1113,1201,825
,0,0,0,603,603,603,609,1634,0,603,603,603,603,0,603,0,603,603,545,561,577
,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649
,0,0,603,0,0,603,0,0,0,603,721,873,0,681,665,0,0,0,0,603,603,603,0,745,777
,0,633,641,0,0,603,603,603,73,889,1033,1089,0,0,603,603,0,1289,0,603,603
,595,603,595,595,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,595,0,0,0,0,595,595,129
,1113,1201,825,0,0,0,595,595,0,609,1634,0,595,595,595,595,0,595,0,595,595
,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,1761,0,0,0,0,593,697
,953,0,0,0,649,0,0,595,0,0,595,0,0,0,595,721,873,0,681,665,0,0,0,0,595,595
,595,0,745,777,0,633,641,0,0,595,595,595,73,889,1033,1089,0,0,595,595,0
,1289,2243,595,595,2763,595,0,2243,0,0,0,0,0,2763,2763,0,0,2243,2763,2763
,0,0,0,0,2243,0,0,2243,0,2763,2763,2763,2763,0,0,2770,2243,0,0,0,0,2243
,2243,2243,2243,0,0,0,0,0,0,2243,2243,2243,0,0,0,0,2243,0,0,2763,2763,2243
,2243,2243,2243,2243,0,2243,2243,2243,2243,2243,2243,0,0,0,0,0,0,0,0,0,0
,2243,2243,2243,0,2243,0,2243,0,0,0,0,0,0,0,0,0,2763,2243,2243,0,2243,2243
,0,0,0,0,0,0,0,0,2243,2243,2763,2243,2243,0,0,0,0,2763,2243,2243,2243,2243
,2763,0,0,0,2243,2243,0,0,595,2243,595,595,0,0,0,0,1209,0,0,0,0,0,0,0,0
,0,595,0,0,0,0,595,595,129,1113,1201,825,0,0,0,595,595,0,609,1634,0,595
,595,595,595,0,0,0,595,595,545,561,577,0,929,0,0,0,2098,809,617,625,0,0
,0,0,0,1761,0,0,0,0,593,697,953,0,0,0,649,0,0,595,0,0,595,0,0,0,595,721
,873,0,681,665,0,0,0,0,595,595,595,0,745,777,0,633,641,0,0,595,595,595,73
,889,1033,1089,0,0,595,595,0,1289,0,595,595,1339,595,1339,1339,0,0,0,0,1209
,0,0,0,0,0,0,0,0,0,1339,0,0,0,0,1339,1339,129,1113,1201,825,0,0,0,1339,1339
,0,609,1634,1339,0,1339,1339,1339,0,0,0,1339,1339,545,561,577,0,929,0,0
,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,1339,0
,0,1339,0,0,0,1339,721,873,0,681,665,0,0,0,0,1339,1339,1339,1339,745,777
,0,633,641,0,0,1339,1339,1339,73,889,1033,1089,0,0,1339,1339,0,1289,0,1339
,1339,659,1339,659,659,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,659,0,0,0,0,659,659
,129,1113,1201,825,0,0,0,659,659,659,609,1634,0,0,659,659,659,0,659,0,659
,659,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697
,953,0,0,0,649,0,0,659,0,0,659,0,0,0,659,721,873,0,681,665,0,0,0,0,659,659
,659,0,745,777,0,633,641,0,0,659,659,659,73,889,1033,1089,0,0,659,659,0
,1289,2251,659,659,2763,659,0,2251,0,0,0,0,0,2763,2763,0,0,2251,2763,2763
,0,0,0,0,2251,0,0,2251,0,2763,2763,2763,2763,0,0,2770,2251,0,0,0,0,2251
,2251,2251,2251,0,0,0,0,0,0,2251,2251,2251,0,0,0,0,2251,0,0,2763,2763,2251
,2251,2251,2251,2251,0,2251,2251,2251,2251,2251,2251,0,0,0,0,0,0,0,0,0,0
,2251,2251,2251,0,2251,1026,2251,2763,2763,0,0,0,0,0,0,2067,2763,2251,2251
,0,2251,2251,0,0,2770,0,2763,0,1034,1042,2251,2251,2763,2251,2251,0,0,0
,0,2763,2251,2251,2251,2251,2763,0,0,0,2251,2251,2763,2763,1355,2251,1355
,1355,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,1355,0,0,0,0,1355,1355,129,1113,1201
,825,0,0,0,1355,1355,0,609,1634,0,2763,1355,1355,1355,0,0,0,1355,1355,545
,561,577,0,929,0,0,1521,2098,809,617,625,0,0,2763,0,0,0,0,0,0,0,593,697
,953,0,0,0,649,0,0,1355,0,0,1355,0,0,0,1355,721,873,0,681,665,0,0,0,0,1355
,1355,1355,1355,745,777,0,633,641,0,0,1355,1355,1355,73,889,1033,1089,0
,0,1355,1355,0,1289,0,1355,1355,1075,1355,1075,1075,0,0,0,0,1209,0,0,0,0
,0,0,0,0,0,1075,0,0,0,0,1075,1075,129,1113,1201,825,0,0,0,1075,1075,0,609
,1634,0,0,1075,1075,1075,0,1075,0,1075,1075,545,561,577,0,929,0,0,0,2098
,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,1075,0,0,1075
,0,0,0,1075,721,873,0,681,665,0,0,0,0,1075,1075,1075,0,745,777,0,633,641
,0,0,1075,1075,1075,73,889,1033,1089,0,0,1075,1075,0,1289,0,1075,1075,1451
,1075,1451,1451,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,1451,0,0,0,0,1451,1451,129
,1113,1201,825,0,0,0,1451,1451,0,609,1634,0,0,1451,1451,1451,0,1451,0,1451
,1451,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697
,953,0,0,0,649,0,0,1451,0,0,1451,0,0,0,1451,721,873,0,681,665,0,0,0,0,1451
,1451,1451,0,745,777,0,633,641,0,0,1451,1451,1451,73,889,1033,1089,0,0,1451
,1451,0,1289,0,1451,1451,1459,1451,1459,1459,0,0,0,0,1209,0,0,0,0,0,0,0
,0,0,1459,0,0,0,0,1459,1459,129,1113,1201,825,0,0,0,1459,1459,0,609,1634
,0,0,1459,1459,1459,0,1459,0,1459,1459,545,561,577,0,929,0,0,0,2098,809
,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,1459,0,0,1459,0,0
,0,1459,721,873,0,681,665,0,0,0,0,1459,1459,1459,0,745,777,0,633,641,0,0
,1459,1459,1459,73,889,1033,1089,0,0,1459,1459,0,1289,0,1459,1459,1467,1459
,1467,1467,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,1467,0,0,0,0,1467,1467,129,1113
,1201,825,0,0,0,1467,1467,0,609,1634,0,0,1467,1467,1467,0,1467,0,1467,1467
,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953
,0,0,0,649,0,0,1467,0,0,1467,0,0,0,1467,721,873,0,681,665,0,0,0,0,1467,1467
,1467,0,745,777,0,633,641,0,0,1467,1467,1467,73,889,1033,1089,0,0,1467,1467
,0,1289,0,1467,1467,1115,1467,1115,1115,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,1115
,0,0,0,0,1115,1115,129,1113,1201,825,0,0,0,1115,1115,0,609,1634,0,0,1115
,1115,1115,0,0,0,1115,1115,545,561,577,0,929,0,0,0,2098,809,617,625,0,0
,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,1115,0,0,1115,0,0,0,1115,721
,873,0,681,665,0,0,0,0,1115,1115,1115,0,745,777,0,633,641,0,0,1115,1115
,1115,73,889,1033,1089,0,0,1115,1115,0,1289,0,1115,1115,1123,1115,1123,1123
,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,1123,0,0,0,0,1123,1123,129,1113,1201,825
,0,0,0,1123,1123,0,609,1634,0,0,1123,1123,1123,0,0,0,1123,1123,545,561,577
,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649
,0,0,1123,0,0,1123,0,0,0,1123,721,873,0,681,665,0,0,0,0,1123,1123,1123,0
,745,777,0,633,641,0,0,1123,1123,1123,73,889,1033,1089,0,0,1123,1123,0,1289
,0,1123,1123,1139,1123,1139,1139,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,1139,0,0
,0,0,1139,1139,129,1113,1201,825,0,0,0,1139,1139,0,609,1634,0,0,1139,1139
,1139,0,0,0,1139,1139,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0
,0,0,0,0,0,593,697,953,0,0,0,649,0,0,1139,0,0,1139,0,0,0,1139,721,873,0
,681,665,0,0,0,0,1139,1139,1139,0,745,777,0,633,641,0,0,1139,1139,1139,73
,889,1033,1089,0,0,1139,1139,0,1289,0,1139,1139,1131,1139,1131,1131,0,0
,0,0,1209,0,0,0,0,0,0,0,0,0,1131,0,0,0,0,1131,1131,129,1113,1201,825,0,0
,0,1131,1131,0,609,1634,0,0,1131,1131,1131,0,0,0,1131,1131,545,561,577,0
,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0
,0,1131,0,0,1131,0,0,0,1131,721,873,0,681,665,0,0,0,0,1131,1131,1131,0,745
,777,0,633,641,0,0,1131,1131,1131,73,889,1033,1089,0,0,1131,1131,0,1289
,0,1131,1131,1147,1131,1147,1147,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,1147,0,0
,0,0,1147,1147,129,1113,1201,825,0,0,0,1147,1147,0,609,1634,0,0,1147,1147
,1147,0,0,0,1147,1147,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0
,0,0,0,0,0,593,697,953,0,0,0,649,0,0,1147,0,0,1147,0,0,0,1147,721,873,0
,681,665,0,0,0,0,1147,1147,1147,0,745,777,0,633,641,0,0,1147,1147,1147,73
,889,1033,1089,0,0,1147,1147,0,1289,0,1147,1147,1379,1147,1379,1379,0,0
,0,0,1209,0,0,0,0,0,0,0,0,0,1379,0,0,0,0,1379,1379,129,1113,1201,825,0,0
,0,1379,1379,0,609,1634,0,0,1379,1379,1379,0,0,0,1379,1379,545,561,577,0
,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0
,0,1379,0,0,1379,0,0,0,1379,721,873,0,681,665,0,0,0,0,1379,1379,1379,0,745
,777,0,633,641,0,0,1379,1379,1379,73,889,1033,1089,0,0,1379,1379,0,1289
,0,1379,1379,1099,1379,1099,1099,0,0,0,0,1209,0,0,0,0,0,0,0,0,0,1099,0,0
,0,0,1099,1099,129,1113,1201,825,0,0,0,1099,1099,0,609,1634,0,0,1099,1099
,1099,0,0,0,1099,1099,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0
,0,0,0,0,0,593,697,953,0,0,0,649,0,0,1099,0,0,1099,0,0,0,1099,721,873,0
,681,665,0,0,0,0,1099,1099,1099,0,745,777,0,633,641,0,0,1099,1099,1099,73
,889,1033,1089,0,0,1099,1099,0,1289,0,1099,1099,1107,1099,1107,1107,0,0
,0,0,1209,0,0,0,0,0,0,0,0,0,1107,0,0,0,0,1107,1107,129,1113,1201,825,0,0
,0,1107,1107,0,609,1634,0,0,1107,1107,1107,0,0,0,1107,1107,545,561,577,0
,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0
,0,1107,0,0,1107,0,0,0,1107,721,873,0,681,665,0,0,0,0,1107,1107,1107,0,745
,777,0,633,641,0,0,1107,1107,1107,73,889,1033,1089,0,0,1107,1107,2035,1289
,0,1107,1107,0,1107,0,0,2035,2035,0,2035,0,2035,2035,0,0,0,0,1209,0,0,0
,0,2035,2035,2035,2035,0,2035,2035,0,2035,0,2035,2035,129,1113,1201,825
,0,0,0,0,0,0,609,1634,2035,0,0,0,0,0,0,0,2035,2035,545,561,577,0,929,0,0
,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0
,0,0,0,0,2035,721,873,0,681,665,0,0,0,0,0,0,0,0,745,777,2035,633,641,0,2027
,0,0,2035,73,889,1033,1089,2035,2027,2027,0,2027,1289,2027,2027,0,0,0,0
,1209,0,0,0,0,2027,2027,2027,2027,0,2027,2027,0,2027,0,2027,2027,129,1113
,1201,825,0,0,0,0,0,0,609,1634,2027,0,0,0,0,0,0,0,2027,2027,545,561,577
,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649
,0,0,0,0,0,0,0,0,0,2027,721,873,0,681,665,0,0,483,0,0,0,0,0,745,777,2027
,633,641,0,0,0,0,2027,73,889,1033,1089,2027,0,483,0,0,1289,1209,483,0,0
,483,0,0,0,0,483,0,0,483,0,483,0,0,129,1113,1201,825,0,0,0,483,0,483,609
,1634,0,0,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,483,2098,809,617,625,0,0
,483,483,483,0,0,0,0,0,593,697,953,483,0,0,649,483,483,0,0,483,483,483,0
,0,0,721,873,0,681,665,0,0,0,483,0,0,0,0,745,777,0,633,641,0,483,0,0,0,73
,889,1033,1089,0,483,2874,2859,0,1289,233,0,2763,0,281,0,0,0,0,2866,0,2763
,2763,0,1026,0,2763,2763,2914,0,0,0,1209,2906,0,0,2922,2763,2763,2763,2763
,0,1321,2770,0,2763,0,1034,1042,129,1113,1201,825,2490,2498,2506,0,0,0,609
,1817,1337,0,0,0,0,0,0,0,2763,2763,545,561,577,0,929,0,0,2938,2098,809,617
,625,2546,0,0,0,0,0,0,2474,0,0,593,697,953,2930,0,0,1825,2890,0,0,0,0,2898
,2946,0,0,2763,721,873,0,681,665,353,0,363,0,0,0,0,0,745,777,2763,633,641
,121,0,0,0,2763,73,889,1033,1089,2763,2882,363,0,0,1289,1209,363,0,0,363
,0,0,0,0,363,0,0,0,0,363,0,0,129,1113,1201,825,0,0,0,363,0,363,609,1634
,0,0,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,363,2098,809,617,625,0,0,363
,363,363,0,0,0,0,0,593,697,953,363,0,0,649,363,363,0,0,363,363,363,0,690
,0,721,873,0,681,665,0,0,0,363,0,0,0,0,745,777,2227,633,641,0,363,0,2227
,0,73,889,1033,1089,0,363,0,683,2227,1289,0,0,683,0,0,2227,0,0,2227,0,0
,0,683,0,683,0,0,169,0,0,0,0,2227,2227,2227,2227,0,0,0,0,0,0,2227,2227,2227
,0,0,0,0,2227,0,683,683,683,2227,2227,2227,2227,2227,0,2227,2227,2227,2227
,2227,2227,0,683,0,0,683,0,0,0,0,0,2227,2227,2227,0,2227,0,2227,0,683,0
,0,0,0,0,0,0,0,2227,2227,683,2227,2227,0,0,0,0,0,0,786,2235,2227,2227,0
,2227,2227,2235,0,0,0,0,2227,2227,2227,2227,0,2235,0,0,2227,2227,0,0,2235
,2227,0,2235,0,0,0,0,779,0,0,0,169,779,0,0,0,2235,2235,2235,2235,0,0,779
,0,779,0,2235,2235,2235,0,0,0,0,2235,0,0,0,0,2235,2235,2235,2235,2235,0
,2235,2235,2235,2235,2235,2235,0,779,779,779,0,0,0,0,0,0,2235,2235,2235
,0,2235,0,2235,779,0,0,779,0,0,0,0,0,0,2235,2235,0,2235,2235,0,0,779,0,0
,0,0,0,2235,2235,0,2235,2235,779,0,1209,0,0,2235,2235,2235,2235,0,0,1499
,2545,2235,2235,0,1499,0,2235,129,1113,1201,825,0,0,0,1499,0,1499,609,1634
,0,0,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,1499,1499
,1499,0,0,0,0,0,593,697,953,0,0,0,649,0,1499,0,0,1499,0,0,0,0,0,721,873
,0,681,665,0,0,0,1499,2874,0,0,0,745,777,0,633,641,0,1499,0,0,0,73,889,1033
,1089,1267,0,1267,1267,2914,1289,0,0,2731,2906,0,0,2922,0,0,0,0,0,1267,1937
,0,0,0,1267,1267,2731,2731,2731,2731,0,0,0,1267,1267,0,2731,2731,1267,0
,1267,1267,1267,0,0,0,1267,1267,2731,2731,2731,0,2731,0,0,2938,2731,2731
,2731,2731,0,2754,0,0,0,0,0,1945,2746,0,2731,2731,2731,2930,0,0,2731,2890
,0,1267,0,0,1267,2946,0,1267,1267,2731,2731,0,2731,2731,0,2738,0,0,1267
,1267,1267,1267,2731,2731,0,2731,2731,2874,0,1267,1267,1267,2731,2731,2731
,2731,0,2882,1267,1267,0,2731,0,1267,1267,939,1267,939,939,2914,0,0,0,0
,2906,0,0,2922,0,0,0,0,0,939,1937,0,0,0,939,939,0,0,0,2874,0,0,506,939,939
,0,0,2705,0,0,939,939,939,0,0,0,939,939,0,0,0,2914,0,0,0,2938,2906,0,0,2922
,0,0,0,0,0,0,0,0,0,0,0,0,0,2930,0,0,0,2890,0,939,0,0,939,2946,2874,0,939
,1178,0,0,0,0,0,0,0,0,939,939,939,0,0,2938,1171,0,1171,1171,2914,939,939
,939,0,2906,2641,0,2922,2882,939,939,0,2930,1171,939,939,2890,939,1171,1171
,0,2898,2946,0,0,0,0,1171,1171,0,0,0,0,0,1171,1171,1171,2682,0,0,1171,1171
,0,0,0,0,2714,2722,0,2938,0,2779,2779,0,2882,0,0,0,0,0,0,0,2674,2690,2698
,2706,0,2930,0,0,425,2890,0,1171,0,0,1171,2946,0,0,1171,0,0,0,0,0,0,0,0
,0,1171,1171,1171,0,2779,2779,0,0,0,0,0,1171,1171,1171,1209,0,0,0,0,2882
,1171,1171,0,0,1963,1171,1171,0,1171,0,0,129,1113,1201,825,0,0,0,0,0,0,609
,1634,1963,2779,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,1409,2098,809,617
,625,0,0,2786,0,0,0,0,1393,0,0,593,697,953,0,0,1963,649,0,0,0,0,0,0,0,0
,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,1955,745,777,0,633,641,0,129,1113
,1201,825,73,889,1033,1089,0,0,609,1634,1955,1289,0,0,0,0,0,0,0,0,545,561
,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,1955
,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,1939,745,777
,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,1939,1289,0
,0,0,0,0,0,0,0,545,561,577,0,929,0,0,2763,2098,809,617,625,0,0,0,0,0,0,0
,0,0,0,593,697,953,0,0,1481,649,2763,0,0,0,0,2763,0,0,2763,0,721,873,1209
,681,665,2770,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889
,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,2249,0,2763,545,561,577,0,929,0
,0,0,2098,809,617,625,0,0,0,0,0,2763,0,0,2225,2763,593,697,953,0,2763,2763
,649,0,0,0,0,0,0,0,0,0,0,721,873,0,681,665,0,0,0,0,0,0,0,1234,745,777,0
,633,641,0,0,2763,0,0,73,889,1033,1089,1243,0,1243,1243,0,1289,0,0,1209
,0,0,153,0,0,0,0,0,0,1243,0,0,0,0,1243,1243,129,1113,1201,825,0,0,0,1243
,1243,0,609,1634,1243,0,1243,1243,1243,0,0,0,1243,1243,545,561,577,0,929
,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,1243
,0,0,1243,1953,1243,1243,1243,721,873,0,681,665,0,1547,0,0,1243,1243,1243
,1243,745,777,0,633,641,0,0,1243,1243,1243,73,889,1033,1089,0,0,1243,1243
,0,1289,1209,1243,1243,0,1243,0,0,0,0,0,0,0,0,0,0,0,0,129,1113,1201,825
,0,0,0,0,0,0,609,1634,0,0,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809
,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721
,873,1209,681,665,153,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825
,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929
,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0
,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,1185,745,777,0,633,641
,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0
,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697
,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,1979
,745,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289
,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,1539,0,0,0
,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665
,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089
,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617
,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873
,1209,681,665,0,0,0,0,0,0,0,2833,745,777,0,633,641,0,129,1113,1201,825,73
,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0
,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0
,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129
,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545
,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0
,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,0,745,777
,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289,0,0
,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0
,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0
,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0,0,609
,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617,625,0
,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209
,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889,1033
,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809
,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721
,873,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825
,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929
,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0
,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0
,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0
,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953
,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,0,745
,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289
,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0
,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0
,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0
,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617
,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873
,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889
,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098
,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0
,0,721,873,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201
,825,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0
,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0
,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641
,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0
,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697
,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,0
,745,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289
,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0
,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0
,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0
,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617
,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873
,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889
,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098
,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0
,0,721,873,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201
,825,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0
,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0
,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641
,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0
,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0,0,0,0,593,697
,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0,0,0,0,0,0,0,0
,745,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0,0,609,1634,0,1289
,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617,625,0,0,0,0,0,0,0
,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873,1209,681,665,0
,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889,1033,1089,0
,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098,809,617
,625,0,0,0,0,0,0,0,0,0,0,593,697,953,0,0,0,649,0,0,0,0,0,0,0,0,0,0,721,873
,1209,681,665,0,0,0,0,0,0,0,0,745,777,0,633,641,0,129,1113,1201,825,73,889
,1033,1089,0,0,609,1634,0,1289,0,0,0,0,0,0,0,0,545,561,577,0,929,0,0,0,2098
,809,617,625,0,0,2874,2859,0,203,1921,0,0,0,593,697,953,0,0,2866,649,0,0
,0,0,0,0,0,2914,0,0,721,873,2906,681,665,2922,0,0,0,0,0,0,0,745,777,0,633
,641,1259,0,1259,1259,0,73,889,1033,1089,0,0,218,203,0,1289,0,0,203,1259
,0,0,0,0,1259,1259,0,0,0,0,2938,0,0,1259,1259,0,0,0,1259,0,1259,1259,1259
,0,0,0,1259,1259,2930,0,0,0,2890,0,0,0,0,2898,2946,0,0,0,0,0,0,0,0,0,0,0
,0,0,0,0,0,0,0,0,0,1259,0,0,1259,0,1865,1259,1259,0,0,0,2882,0,0,0,0,0,1259
,1259,1259,1259,0,0,0,0,0,0,0,1259,1259,1259,611,0,611,611,0,0,1259,1259
,0,0,0,1259,1259,0,1259,0,0,0,611,0,1785,0,0,611,611,0,0,0,0,0,0,0,611,611
,611,0,0,0,611,611,611,611,0,611,0,611,611,1331,0,1331,1331,0,0,0,0,0,0
,0,0,0,0,0,0,0,0,1331,0,0,0,0,1331,1331,0,0,0,0,0,0,611,1331,1331,611,0
,0,1331,611,1331,1331,1331,0,0,0,1331,1331,0,611,611,611,0,0,0,0,0,0,0,0
,611,611,611,0,0,0,0,0,0,611,611,2065,1178,0,611,611,0,611,0,1331,0,0,1331
,0,0,1849,1331,1171,0,1171,1171,0,0,0,0,0,1331,1331,1331,1331,0,0,0,0,0
,1171,0,1331,1331,1331,1171,1171,0,0,0,0,1331,1331,0,1171,1171,1331,1331
,0,1331,0,1171,1171,1171,0,0,0,1171,1171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
,0,1835,1835,0,0,1835,0,0,0,1835,0,0,0,0,1835,1171,0,0,1171,0,0,0,1171,1835
,0,0,0,0,1835,0,0,1835,1171,1171,1171,0,0,0,0,0,0,0,0,1171,1171,1171,0,0
,1835,1835,1835,0,1171,1171,0,1835,0,1171,1171,0,1171,0,0,0,0,0,0,0,0,1835
,0,1850,1835,1835,0,0,0,0,1835,643,0,643,643,0,0,1835,0,0,0,0,0,1842,1835
,0,1835,1835,0,643,0,0,1835,1835,643,643,0,0,0,0,0,0,1835,643,643,0,0,0
,0,1729,643,643,643,0,643,1835,643,643,0,0,0,0,0,2874,2897,1835,66,0,1835
,0,0,0,0,1835,0,0,0,0,0,0,0,0,0,0,0,2914,0,0,0,643,2906,0,643,2922,0,0,643
,0,0,0,0,0,0,0,0,0,643,643,643,0,0,0,0,0,0,0,0,643,643,643,0,0,0,0,0,0,643
,643,2850,0,2843,643,643,2427,643,2938,0,2427,0,2427,2427,2427,2427,2427
,0,2427,0,2427,2427,0,0,0,0,2930,0,0,2427,2890,2427,2427,2427,2427,2898
,2946,2427,2427,2427,0,2427,2427,1347,0,1347,1347,0,0,0,0,0,0,0,0,2427,0
,0,0,0,0,1347,0,2427,2427,0,1347,1347,2882,0,0,2874,0,0,0,1347,1347,0,0
,0,1833,0,1347,1347,1347,0,0,0,1347,1347,0,0,0,2914,0,0,0,0,2906,0,0,2922
,0,2427,0,0,0,0,1937,0,0,0,0,0,0,0,0,0,0,2427,0,1347,0,0,1347,0,2427,0,1347
,826,0,2427,0,0,0,0,0,0,1347,1347,1347,1347,0,2938,819,0,819,819,0,1347
,1347,1347,0,0,0,1945,0,0,1347,1347,0,2930,819,1347,1347,2890,1347,819,819
,0,2898,2946,0,0,0,0,819,819,0,0,0,0,0,819,819,819,0,0,0,819,819,795,0,795
,795,0,0,0,0,0,0,0,0,2882,0,0,0,0,0,795,0,0,2441,0,795,795,0,0,0,0,0,0,819
,795,795,819,0,0,0,819,795,795,795,0,0,0,795,795,0,819,819,819,0,0,0,0,0
,0,0,0,819,819,819,0,0,0,0,0,0,819,819,0,0,0,819,819,0,819,0,795,0,0,795
,0,0,0,795,643,0,643,643,0,0,0,0,0,795,795,795,0,0,0,0,0,0,643,0,795,795
,795,643,643,0,0,0,0,795,795,0,643,643,795,795,0,795,1729,643,643,643,0
,0,978,643,643,0,0,0,0,0,0,0,0,0,0,0,0,971,0,971,971,0,0,0,0,0,0,0,0,0,0
,0,0,0,0,971,643,0,0,643,971,971,0,643,0,0,0,0,0,971,971,0,0,643,643,643
,971,971,971,0,0,0,971,971,643,643,643,0,0,754,0,0,0,643,643,0,0,435,643
,643,435,643,0,0,0,435,0,435,435,0,0,0,0,0,0,971,0,0,971,435,0,747,971,0
,435,0,747,435,0,0,0,0,971,971,971,0,747,0,747,0,0,0,0,971,971,971,2874
,2859,0,0,233,0,971,971,281,0,0,971,971,2866,971,0,0,0,0,747,747,747,2914
,435,0,0,0,2906,0,1522,2922,0,0,0,435,747,0,0,747,0,0,435,0,0,0,435,0,2490
,2498,2506,435,435,747,0,2410,0,1363,0,1363,1363,0,1515,0,747,0,0,1515,0
,2211,0,0,2211,2938,0,1363,0,1515,2546,1515,1363,1363,0,0,435,2474,0,0,0
,1363,1363,2930,2211,0,2426,2890,1363,1363,1363,0,2898,2946,1363,1363,0
,0,1515,1515,1515,0,353,0,0,0,0,0,0,0,0,0,0,0,1515,121,0,1515,0,0,0,0,0
,0,0,2882,0,1363,2211,0,1363,1515,0,2211,1363,0,0,0,0,0,0,0,1515,0,1363
,1363,1363,1713,0,0,795,0,795,795,0,1363,1363,1363,0,0,0,0,0,0,1363,1363
,0,0,795,1363,1363,2441,1363,795,795,0,0,0,0,0,0,0,795,795,0,0,0,0,0,795
,795,795,0,0,0,795,795,795,0,795,795,0,0,0,0,0,0,0,0,0,0,0,0,0,0,795,0,0
,2441,0,795,795,0,0,0,0,0,0,795,795,795,795,0,0,0,795,795,795,795,0,0,0
,795,795,0,795,795,795,0,0,0,0,0,0,0,0,795,795,795,0,0,0,0,0,0,795,795,0
,0,0,795,795,0,795,0,795,0,0,795,0,0,0,795,1411,0,1411,1411,0,0,0,0,0,795
,795,795,0,0,0,0,0,0,1411,0,795,795,795,1411,1411,0,0,0,0,795,795,0,1411
,1411,795,795,0,795,0,1411,1411,1411,0,2209,0,1411,1411,1026,0,2779,2779
,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2489,0,0,0,0,1034,1042,0,0,0,0,0,0,1411,2425
,2281,1411,0,0,0,1411,987,2033,1202,0,0,0,2779,2779,0,1411,1411,1411,0,0
,0,0,0,0,0,0,1411,1411,1411,0,0,0,0,0,0,1411,1411,0,0,0,1411,1411,0,1411
,0,2169,0,0,1195,0,0,0,2779,1026,0,2779,2779,0,0,0,0,0,987,2089,2049,0,0
,0,0,0,0,1625,0,2121,2129,2786,1034,1042,0,0,0,0,2105,1195,0,2425,2281,994
,2073,0,1969,0,987,2033,1202,0,0,0,2779,2779,835,0,835,835,0,0,0,0,0,0,0
,0,0,0,0,0,0,0,835,0,0,0,0,835,835,0,0,0,0,0,0,2169,835,835,1195,0,0,0,2779
,835,835,835,0,0,0,835,835,0,987,2089,2049,0,0,0,0,0,0,0,0,2121,2129,2786
,0,0,0,0,0,0,2105,1195,0,0,0,994,2073,0,1969,0,835,0,0,835,0,0,0,835,1026
,0,2779,2779,0,0,0,0,0,835,835,835,0,0,0,0,0,0,2785,0,835,835,835,1034,1042
,0,0,0,0,835,835,0,2425,2281,835,835,0,835,0,987,2033,1202,0,0,0,2779,2779
,835,0,835,835,0,0,0,0,0,0,0,0,0,0,0,0,0,0,835,0,0,0,0,835,835,0,0,0,0,0
,0,2169,835,835,1195,0,0,0,2779,835,835,835,0,0,0,835,835,0,987,2089,2049
,0,0,0,0,0,0,0,0,2121,2129,2786,0,0,0,0,0,0,2105,1195,0,0,0,994,2073,0,1969
,0,835,0,0,835,0,0,0,835,835,0,835,835,0,0,0,0,0,835,835,835,0,0,0,0,0,0
,835,0,835,835,835,835,835,0,0,0,0,835,835,0,835,835,835,835,0,835,0,835
,835,835,0,0,0,835,835,0,0,0,0,0,0,707,0,0,0,0,0,0,0,0,0,0,1691,1691,0,0
,1691,0,0,0,1691,0,0,707,0,1691,835,0,707,835,0,707,0,835,1714,1706,1722
,0,0,1691,0,0,1691,835,835,835,0,1698,0,0,0,0,0,0,835,835,835,0,0,1691,1691
,1691,0,835,835,0,1691,0,835,835,0,835,0,707,0,0,0,2874,2859,0,714,233,0
,0,1691,281,0,0,0,1691,2866,707,0,0,0,707,1691,0,0,2914,707,707,1691,0,2906
,1691,1691,2922,0,0,0,1691,1691,0,0,0,0,0,0,0,0,1691,0,0,2490,2498,2506
,0,0,0,0,2410,0,707,1691,2874,2859,0,0,233,0,0,0,281,1691,0,0,0,2866,2938
,0,0,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890,0,0
,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0
,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906
,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506
,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0
,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890,0
,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859,0
,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,0,0,2874,2859,0,0,233,0,121,0,281,0,0,0,0,2866,2938
,0,2882,0,0,2546,0,0,2914,0,0,0,2474,2906,0,0,2922,0,2930,0,0,2426,2890
,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,0,2410,0,0,0,2874,2859
,0,0,233,0,121,0,281,0,0,0,0,2866,2938,0,2882,0,0,2546,0,0,2914,0,0,0,2474
,2906,0,0,2922,0,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498
,2506,0,353,0,0,2410,0,731,0,427,731,0,427,0,0,121,0,427,0,450,458,0,0,2938
,738,2882,0,0,2546,731,0,427,0,0,731,2474,427,731,0,427,0,2930,731,0,2426
,2890,0,731,0,0,2898,2946,0,0,0,0,0,731,0,731,353,0,0,2874,2859,0,0,233
,0,0,0,281,0,121,0,0,2866,0,0,731,0,427,0,2882,0,2914,731,731,731,0,2906
,0,427,2922,0,0,0,731,0,427,0,731,731,427,0,731,731,731,427,427,2490,2498
,2506,0,0,0,0,2410,0,731,0,2874,2859,0,0,233,0,0,0,281,731,0,0,0,2866,2938
,0,0,0,731,2546,427,0,2914,0,0,0,2474,2906,0,0,2922,2874,2930,0,2795,2426
,2890,0,0,0,0,2898,2946,0,0,0,0,2490,2498,2506,0,353,0,2914,2410,0,0,0,2906
,0,0,2922,0,0,121,0,2795,0,0,0,0,2795,2938,0,2882,0,0,2546,0,0,0,2795,0
,2795,2474,0,2874,0,0,2795,2930,0,0,2426,2890,0,0,0,0,2898,2946,0,0,2938
,0,0,0,0,2914,353,2795,2795,2795,2906,0,2874,2922,0,2795,0,0,2930,121,0
,0,2890,2795,0,0,2795,2898,2946,2882,0,0,0,0,2914,0,0,0,0,2906,2795,0,2922
,0,0,0,0,2795,0,0,0,2795,2795,0,0,2938,0,0,0,0,2882,0,2795,0,2795,0,0,0
,2874,0,0,2795,0,2930,0,0,0,2890,0,0,0,0,2898,2946,2938,0,0,0,0,0,2914,2795
,2795,2795,0,2906,0,0,2922,0,0,0,2930,2795,0,0,2890,2795,2795,0,2795,2898
,2946,0,0,2882,0,0,2795,0,2795,0,0,0,2795,0,0,0,0,0,0,0,0,0,515,2795,0,0
,0,0,2938,0,0,0,2882,0,0,2795,2795,2795,0,0,0,0,0,0,515,0,2930,0,0,515,2890
,2795,515,0,2795,2898,2946,515,0,0,2657,0,515,0,0,2874,2859,0,2795,233,0
,0,515,281,515,0,0,0,2866,2795,0,0,0,0,0,0,2779,2914,2882,0,0,0,2906,0,515
,2922,0,0,0,0,0,515,515,515,0,0,0,0,0,0,0,0,515,0,0,0,515,515,0,2410,515
,515,515,0,0,0,0,0,0,0,0,0,0,0,515,0,0,2938,0,0,0,0,2546,0,0,515,2874,0
,0,0,0,0,0,0,515,2930,0,2763,2426,2890,0,0,0,0,2898,2946,2763,2763,2914
,1026,0,2763,2763,2906,353,0,2922,0,0,0,0,339,2763,2763,2763,2763,339,121
,2770,0,2763,2786,1034,1042,0,0,339,2882,339,0,0,0,0,0,0,0,1337,2874,0,0
,0,0,0,0,2763,2763,0,0,2938,0,0,0,0,0,0,339,339,339,0,2914,0,0,0,0,2906
,0,2930,2922,2763,0,2890,339,307,0,339,2898,2946,307,0,0,0,0,0,0,2763,0
,0,307,339,307,2763,0,0,2874,0,2763,0,0,2763,339,2763,0,0,0,0,2770,0,2763
,2882,2938,0,0,2763,0,0,2914,307,307,307,0,2906,0,0,2922,0,0,0,2930,371
,0,0,2890,307,371,0,307,2898,2946,0,0,2763,0,0,371,0,371,0,0,0,307,0,0,0
,0,2874,0,0,0,2763,0,307,0,2763,0,0,2938,0,2763,2763,2882,0,0,371,371,371
,0,2914,0,0,0,0,2906,0,2930,2922,0,0,2890,371,27,0,371,2898,2946,27,0,0
,0,0,0,2763,0,0,0,27,371,27,0,0,0,2874,2859,0,0,233,0,371,0,281,0,0,0,0
,2866,0,2882,2938,0,0,0,0,0,2914,27,27,27,0,2906,0,0,2922,0,0,0,2930,0,0
,0,2890,27,0,0,27,2898,2946,0,0,0,0,0,0,2874,2859,0,2410,233,27,0,0,281
,0,0,2874,2859,2866,0,233,27,0,0,281,0,2938,2914,0,2866,2882,2546,2906,0
,0,2922,0,0,2914,0,0,0,0,2906,2930,0,2922,2426,2890,0,0,0,0,2898,2946,0
,0,0,0,2410,0,0,0,353,0,0,0,2874,2859,0,2410,233,0,0,0,281,121,2938,0,0
,2866,0,2546,0,0,0,2882,0,2938,2914,0,0,0,2546,2906,2930,0,2922,2426,2890
,0,0,0,0,2898,2946,2930,0,0,2426,2890,0,0,0,353,2898,2946,0,0,0,0,2410,0
,0,0,353,0,121,2874,2859,0,0,233,0,0,0,281,2882,121,2938,0,2866,0,0,2546
,0,0,0,2882,0,2914,0,0,0,0,2906,0,2930,2922,0,2426,2890,0,0,0,0,2898,2946
,0,0,0,2874,2859,0,0,233,353,0,0,281,0,0,2410,0,2866,0,0,0,0,121,0,0,0,2914
,0,0,0,0,2906,2882,2938,2922,2874,2859,0,2546,233,0,0,0,281,0,0,0,0,2866
,0,0,2930,0,0,2426,2890,0,2914,2410,0,2898,2946,2906,0,0,2922,0,0,0,0,353
,0,0,0,0,0,2938,0,2874,2859,0,2546,233,121,0,0,281,0,0,2410,0,2866,0,2882
,2930,0,0,2426,2890,0,2914,0,0,2898,2946,2906,0,2938,2922,0,0,0,2546,353
,0,0,0,0,0,0,0,0,0,0,0,2930,121,0,2426,2890,0,0,2410,0,2898,2946,2882,0
,0,2874,2859,0,0,233,353,0,0,281,0,0,2938,0,2866,0,0,2546,0,121,0,0,0,2914
,0,0,0,0,2906,2882,2930,2922,0,2426,2890,0,0,0,0,2898,2946,0,0,0,2874,2859
,0,0,233,353,0,0,281,0,0,2410,0,2866,0,0,0,0,121,0,0,0,2914,0,0,0,0,2906
,2882,2938,2922,2874,2859,0,2546,233,0,0,0,281,0,0,0,0,2866,0,0,2930,0,0
,2426,2890,0,2914,2410,0,2898,2946,2906,0,0,2922,0,0,0,0,353,0,0,0,0,0,2938
,0,2874,2859,0,2546,233,121,0,0,281,0,0,2410,0,2866,0,2882,2930,0,0,2426
,2890,0,2914,0,0,2898,2946,2906,0,2938,2922,0,0,0,2546,353,0,0,0,0,0,0,0
,0,0,0,0,2930,121,0,2426,2890,0,0,2410,0,2898,2946,2882,0,0,2874,2859,0
,0,233,353,0,0,281,0,0,2938,0,2866,0,0,2546,0,121,0,0,0,2914,0,0,0,0,2906
,2882,2930,2922,2763,2426,2890,0,0,0,0,2898,2946,2763,2763,0,0,0,2763,2763
,0,353,0,0,0,0,0,2410,0,2763,2763,2763,2763,0,121,2770,0,0,2874,2859,0,0
,0,251,2882,2938,0,0,0,0,2546,2866,0,0,0,0,0,0,2395,0,2914,2763,2763,2930
,0,2906,2426,2890,2922,0,0,0,2898,2946,0,0,0,0,0,0,0,0,353,0,0,0,2874,2859
,0,0,0,251,290,0,0,121,0,0,0,2866,2874,2763,0,0,0,2882,0,0,2914,0,2938,0
,0,2906,0,2546,2922,2763,0,0,2874,2859,2914,0,2763,0,0,2906,2930,2763,2922
,0,2890,2866,2874,0,0,2898,2946,0,290,0,2914,0,0,0,0,2906,0,0,2922,0,0,0
,0,0,2914,0,2938,0,121,2906,0,2546,2922,0,0,0,0,0,2882,2874,2938,0,290,0
,2930,2546,0,0,2890,0,2874,0,0,2898,2946,0,0,0,2930,0,2938,2914,2890,0,0
,2546,2906,2898,2946,2922,0,0,2914,0,2938,0,121,2906,2930,2546,2922,0,2890
,0,0,2874,2882,2898,2946,0,121,0,2930,0,0,0,2890,0,0,0,2882,2898,2946,0
,0,0,0,2914,0,0,121,2938,2906,0,0,2922,2546,0,0,0,2882,2874,2938,0,121,0
,0,2546,0,2930,0,0,0,2890,2882,0,2874,0,2898,2946,2930,0,0,2914,2890,0,0
,2874,2906,2898,2946,2922,0,0,0,0,0,2938,2914,0,0,121,2546,2906,0,0,2922
,2874,0,2914,0,2882,121,0,2906,2930,0,2922,0,2890,0,0,2882,0,2898,2946,0
,0,0,2914,0,0,0,2938,2906,0,0,2922,2546,0,0,2874,0,0,0,0,0,121,2938,0,0
,2930,0,2546,0,2890,0,2882,0,2938,2898,2946,0,2914,2546,0,2930,0,2906,0
,2890,2922,2874,0,0,2898,2946,2930,0,2938,0,2890,0,121,2546,0,2898,2946
,0,0,0,0,0,2882,2914,0,0,2930,121,2906,0,2890,2922,2874,0,0,2898,2946,2882
,121,0,0,0,2938,0,0,0,0,2546,2882,2874,0,0,2795,0,2914,0,0,0,121,2906,2930
,0,2922,0,2890,0,2874,0,2882,2898,2946,2914,0,2938,2705,0,2906,0,2546,2922
,0,0,0,2763,0,2874,0,0,2914,0,0,2930,121,2906,0,2890,2922,2874,0,0,2898
,2946,2882,0,2938,2763,0,2914,0,2546,2763,0,2906,2763,2874,2922,0,2795,0
,2914,2770,2938,2930,121,2906,0,2890,2922,0,0,0,2898,2946,2882,1937,0,2914
,0,2938,2930,2874,2906,0,2890,2922,0,0,0,2898,2946,0,0,0,0,121,2763,2930
,2938,0,0,2890,0,2914,0,2882,2898,2946,2906,0,2938,2922,0,0,2763,0,2930
,0,2763,0,2890,2874,2882,2763,2763,2898,2946,2938,2930,0,0,0,2890,0,0,2874
,0,2898,2946,2882,0,0,2874,2914,0,2930,0,0,2906,2890,0,2922,0,2938,2898
,2946,2763,2914,2882,0,498,2874,2906,0,2914,2922,0,0,0,2906,2882,2930,2922
,0,0,2890,2874,0,2874,0,2898,2946,0,2914,0,0,0,2882,2906,0,0,2922,0,2938
,0,0,0,2874,2914,0,2914,0,0,2906,0,2906,2922,2938,2922,0,0,2930,0,2882,2938
,2890,0,2874,0,2914,2898,2946,0,0,2906,2930,0,2922,0,2890,0,0,2930,2938
,2898,2946,2890,0,0,2914,0,2898,2946,0,2906,0,0,2922,2938,0,2938,2930,0
,2882,0,2890,0,0,2874,0,2898,2946,0,0,0,0,2930,2882,2930,2938,2890,0,2890
,2874,2882,2898,2946,2898,2946,0,2914,0,0,0,0,2906,0,2930,2922,2938,0,2890
,2874,2882,0,2914,2898,2946,0,0,2906,0,0,2922,2874,0,0,2930,2882,0,2882
,2890,0,0,2914,0,2898,2946,0,2906,0,0,2922,0,0,0,2914,0,0,2882,2938,2906
,0,0,2922,0,0,0,2874,0,0,0,0,0,0,2938,0,0,2930,2882,0,0,2890,2874,0,0,0
,2898,2946,0,2914,0,0,2930,2938,2906,0,2890,2922,0,0,0,2898,2946,0,2914
,2938,0,0,2874,2906,0,2930,2922,0,0,2890,0,0,0,2882,2898,2946,2874,2930
,0,0,0,2890,0,2874,2914,0,2898,2946,2882,2906,0,0,2922,2938,0,0,0,0,2914
,0,0,0,2874,2906,0,2914,2922,2882,2938,0,2906,2930,0,2922,0,2890,0,2874
,0,2882,2898,2946,0,0,2914,0,2930,0,0,2906,2890,0,2922,0,2938,2898,2946
,2874,0,2914,0,0,0,0,2906,0,0,2922,2938,0,0,0,2930,2882,0,2938,2890,2874
,0,2914,0,2898,2946,0,2906,0,2930,2922,2882,0,2890,0,0,2930,2938,2898,2946
,2890,0,2914,0,0,2898,2946,2906,0,0,2922,0,2938,0,2874,2930,0,2882,0,2890
,0,2874,0,0,2898,2946,0,0,0,0,2930,2882,2938,0,2890,0,2914,0,2882,2898,2946
,2906,0,2914,2922,0,0,0,2906,0,2930,2922,2938,0,2890,2874,0,2882,0,2898
,2946,0,0,0,0,0,0,2874,0,2874,2930,0,2882,0,2890,0,0,2914,0,2898,2946,0
,2906,0,0,2922,2938,0,0,2914,0,2914,2882,2938,2906,0,2906,2922,0,2922,0
,0,0,2874,2930,0,0,0,2890,0,2874,2930,2882,2898,2946,2890,0,0,0,0,2898,2946
,0,0,0,2914,0,2938,0,0,2906,0,2914,2922,0,0,0,2906,0,2938,2922,2938,0,0
,0,2930,2882,0,0,2890,2874,0,0,2882,2898,2946,0,2930,0,2930,0,2890,2874
,2890,2874,0,2898,2946,2898,2946,0,0,2914,0,0,2938,0,2906,0,0,2922,0,2938
,0,2914,2874,2914,2882,0,2906,0,2906,2922,2930,2922,0,0,2890,0,2882,2930
,2882,2898,2946,2890,0,0,2914,0,2898,2946,0,2906,0,0,2922,0,0,0,0,0,0,2938
,0,0,0,0,0,0,0,0,0,0,0,2938,2882,2938,0,0,0,2930,0,2882,0,2890,0,0,0,0,2898
,2946,0,2930,0,2930,0,2890,2938,2890,0,0,2898,2946,2898,2946,0,0,0,0,0,0
,0,0,0,0,2930,0,0,0,2890,0,0,2882,0,2898,2946,0,0,0,0,0,0,0,0,2882,0,2882
,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2882}
,
{1,11,84,11,11,109,11,11,11,109,11,11,85,11,11,11,11,11,11,11,11,11,11,11
,17,238,11,11,11,11,11,11,11,11,11,11,104,11,11,11,11,290,11,11,11,11,11
,11,285,294,17,11,11,271,11,11,11,234,11,11,11,11,234,285,11,11,11,11,11
,11,11,272,11,11,11,11,11,11,104,190,136,190,190,190,136,291,11,133,11,11
,11,11,11,32,11,11,32,11,32,295,11,11,136,314,11,11,11,190,11,11,133,271
,206,314,11,11,11,297,11,11,11,11,11,151,5,11,11,11,11,11,11,11,11,11,11
,11,11,11,240,11,11,11,11,13,314,13,13,206,13,13,13,272,13,13,151,13,13
,13,13,13,13,13,13,13,13,13,123,14,13,13,13,13,13,13,13,13,13,13,132,13
,13,13,13,164,13,13,13,13,13,13,33,271,123,13,13,95,13,13,13,95,13,13,13
,13,132,14,13,13,13,13,13,13,13,164,13,13,13,13,13,13,242,176,129,176,176
,176,129,80,13,80,13,13,13,13,13,123,13,13,147,13,179,321,13,13,129,321
,13,13,13,176,13,13,195,248,188,181,13,13,13,179,13,13,13,13,13,244,147
,13,13,13,13,13,13,13,13,13,13,13,13,13,188,13,13,13,13,26,181,26,26,154
,30,26,26,30,26,26,179,26,26,26,26,26,26,26,26,26,26,26,154,248,185,26,26
,26,26,26,26,26,26,26,114,26,26,26,26,117,26,26,26,26,26,26,88,9,155,26
,26,9,26,26,26,185,26,26,26,26,114,298,26,26,26,26,26,26,26,156,26,26,26
,26,26,26,192,298,192,192,192,298,120,157,26,120,26,26,26,26,26,289,26,26
,192,26,99,264,26,26,99,35,26,26,26,120,26,26,53,53,265,289,26,26,26,44
,26,26,26,26,26,35,310,26,26,26,26,26,26,26,26,26,26,26,26,26,139,26,26
,26,26,148,148,299,223,148,139,202,148,120,59,53,53,264,120,160,121,148
,148,299,148,101,148,148,148,101,265,91,148,148,223,127,148,148,148,148
,148,148,148,148,148,148,148,148,148,148,148,148,148,207,317,53,148,148
,148,148,148,148,148,148,148,148,141,148,68,148,148,148,148,148,127,148
,124,127,148,148,148,148,148,165,107,148,148,148,107,126,148,93,141,148
,148,148,148,127,148,148,148,148,148,29,148,148,148,323,148,148,148,148
,168,148,148,126,70,326,148,148,148,148,148,148,148,148,148,148,46,148,148
,148,148,148,148,148,148,148,148,148,148,127,148,97,148,148,127,148,149
,149,130,72,149,268,332,149,269,334,74,178,134,178,178,178,149,149,338,149
,273,149,149,149,75,341,102,149,149,137,76,149,149,149,149,149,149,149,149
,149,149,149,149,149,149,149,149,149,77,105,347,149,149,149,149,149,149
,149,149,149,149,178,149,280,149,149,149,149,149,78,149,79,27,149,149,149
,149,149,144,353,149,149,149,81,355,149,82,83,149,149,149,149,288,149,149
,149,149,149,112,149,149,149,360,149,149,149,149,361,149,149,362,362,362
,149,149,149,149,149,149,149,149,149,149,362,149,149,149,149,149,149,149
,149,149,149,149,149,362,149,362,149,149,362,149,57,57,362,362,57,57,362
,57,57,362,57,57,57,57,57,362,57,57,57,57,87,362,362,362,57,362,57,57,362
,57,57,57,57,362,57,57,57,87,87,57,57,57,57,57,57,362,362,362,57,57,303
,57,57,57,362,57,57,57,57,362,362,57,57,57,57,57,57,57,362,57,57,57,57,57
,57,362,362,362,362,362,87,87,362,57,303,57,57,57,362,57,362,57,362,362
,57,362,362,57,90,90,303,57,57,57,303,57,57,362,362,362,362,57,57,57,362
,57,57,57,57,57,87,362,57,57,57,57,57,57,57,57,303,57,57,57,57,362,57,57
,57,57,226,90,90,87,226,362,226,226,226,226,226,362,226,362,226,226,362
,362,362,362,226,362,362,226,362,226,226,226,226,362,226,226,226,226,362
,226,226,226,226,226,226,90,362,362,226,226,226,226,226,226,226,226,226
,226,362,226,362,226,226,226,226,226,362,226,90,362,362,226,226,226,226
,362,64,362,64,64,64,362,362,362,362,226,226,226,362,362,362,226,362,362
,226,362,362,226,362,362,362,226,226,226,64,226,226,362,362,362,362,226
,226,226,362,226,226,226,226,226,236,362,226,226,226,226,226,226,226,226
,362,226,226,362,226,293,226,226,236,226,236,236,236,362,362,362,236,236
,362,362,236,293,362,362,362,293,236,236,362,4,4,236,236,236,236,236,236
,362,362,362,236,236,362,236,236,236,362,236,236,236,362,293,362,236,236
,236,236,236,362,236,362,362,236,236,236,236,236,362,287,362,362,362,4,4
,236,362,362,236,236,236,236,362,362,236,236,362,236,362,362,236,236,362
,236,236,236,236,362,236,236,362,362,287,362,236,236,236,236,236,236,362
,236,236,4,362,236,236,236,236,236,236,236,287,236,236,236,362,236,39,236
,236,39,236,362,39,39,4,39,39,39,39,39,362,39,39,39,39,362,287,362,362,39
,362,39,39,362,39,39,39,39,0,362,39,39,39,0,39,39,39,39,39,39,362,362,362
,0,362,0,39,39,39,362,362,362,362,39,362,362,39,39,39,39,39,39,39,301,39
,39,39,39,39,39,362,362,0,0,0,362,362,362,362,301,39,39,39,301,39,362,39
,362,0,362,0,0,362,362,362,362,39,39,39,362,39,39,362,362,0,0,362,51,51
,301,39,39,39,39,39,362,0,362,362,39,39,39,39,39,39,362,51,362,39,39,49
,49,362,39,49,362,362,49,49,362,49,49,49,49,49,362,362,49,49,49,51,51,362
,362,49,362,49,49,362,49,49,49,49,362,362,49,49,362,362,362,362,49,49,49
,49,362,362,362,362,362,362,49,49,49,362,362,362,362,49,362,51,49,49,49
,49,49,49,49,362,49,49,49,49,49,49,48,362,48,48,362,362,362,362,51,362,49
,49,49,362,49,362,49,362,362,48,362,48,362,48,48,362,49,49,49,362,49,49
,362,362,362,362,362,362,362,362,49,49,49,49,49,48,48,362,362,49,49,49,49
,49,49,362,362,362,49,49,362,38,362,49,38,362,362,38,38,362,38,38,38,38
,38,362,362,38,38,38,362,362,362,362,38,48,362,38,362,38,38,38,38,362,362
,38,38,362,362,362,362,38,38,38,38,362,362,362,48,362,362,38,38,38,362,362
,362,362,38,362,362,38,38,38,38,38,38,38,362,38,38,38,38,38,38,362,50,362
,50,50,362,362,362,362,362,38,38,38,362,38,362,38,362,362,362,50,362,50
,362,50,50,38,38,38,362,38,38,362,362,362,362,362,362,362,362,38,38,38,38
,38,362,50,50,362,38,38,38,38,38,38,362,362,362,38,38,362,24,362,38,24,362
,362,24,24,362,24,24,24,24,24,362,362,24,24,24,362,362,362,362,24,362,50
,24,362,24,24,24,24,2,362,24,24,362,2,362,362,24,24,24,24,362,362,362,2
,50,2,24,24,24,362,362,362,362,24,362,362,24,24,24,24,24,24,24,362,24,24
,24,24,24,24,362,362,2,2,2,362,362,362,362,362,24,24,24,362,24,362,24,362
,2,362,362,2,362,362,362,362,24,24,24,362,24,24,362,362,362,2,362,362,362
,362,24,24,24,24,24,362,2,362,362,24,24,24,24,24,24,362,362,362,24,24,362
,62,362,24,62,362,362,62,62,362,62,62,62,62,62,362,362,62,62,62,362,362
,362,362,62,362,362,62,362,62,62,62,62,3,362,62,62,362,3,362,362,62,62,62
,62,362,362,362,3,362,3,62,62,62,362,362,362,362,62,362,362,62,62,62,62
,62,62,62,362,62,62,62,62,62,62,362,362,3,3,3,362,362,362,362,362,62,62
,62,362,62,362,62,362,3,111,362,3,362,362,362,362,62,62,62,362,62,62,111
,111,362,3,362,362,362,362,62,62,62,62,62,362,3,362,362,62,62,62,62,62,62
,362,362,362,62,62,362,66,362,62,66,362,362,66,66,362,66,66,66,66,66,111
,111,66,66,66,362,362,362,362,66,362,362,66,362,66,66,66,66,362,362,66,66
,111,362,362,362,66,66,66,66,362,362,362,362,362,362,66,66,66,362,111,362
,362,66,362,362,66,66,66,66,66,66,66,362,66,66,66,66,66,66,362,362,362,111
,362,362,362,362,362,22,66,66,66,362,66,362,66,362,22,22,362,362,362,22
,22,362,66,66,66,362,66,66,362,362,22,22,22,22,362,362,66,66,66,66,66,362
,362,362,362,66,66,66,66,66,66,362,362,362,66,66,362,362,225,66,225,225
,22,22,362,362,225,362,362,362,362,362,362,362,362,362,225,362,225,362,362
,225,225,225,225,225,225,362,362,362,225,225,225,225,225,362,225,225,225
,225,362,225,22,225,225,225,225,225,362,225,362,362,362,225,225,225,225
,362,22,362,362,362,362,362,362,22,362,225,225,225,22,362,362,225,362,362
,225,362,362,225,362,362,362,225,225,225,362,225,225,362,362,362,362,225
,225,225,362,225,225,362,225,225,362,362,225,225,225,225,225,225,225,362
,362,225,225,362,225,362,225,225,220,225,220,220,362,362,362,362,220,362
,362,362,362,362,362,362,362,362,220,362,362,362,362,220,220,220,220,220
,220,362,362,362,220,220,220,220,220,362,220,220,220,220,362,220,362,220
,220,220,220,220,362,220,362,362,362,220,220,220,220,362,362,362,362,362
,362,362,362,362,362,220,220,220,362,362,362,220,362,362,220,362,362,220
,362,362,362,220,220,220,362,220,220,362,362,362,362,220,220,220,362,220
,220,362,220,220,362,362,220,220,220,220,220,220,220,362,362,220,220,362
,220,362,220,220,245,220,245,245,362,362,362,362,245,362,362,362,362,362
,362,362,362,362,245,362,362,362,362,245,245,245,245,245,245,362,362,362
,245,245,362,245,245,362,245,245,245,245,362,245,362,245,245,245,245,245
,362,245,362,362,362,245,245,245,245,362,362,362,362,362,245,362,362,362
,362,245,245,245,362,362,362,245,362,362,245,362,362,245,362,362,362,245
,245,245,362,245,245,362,362,362,362,245,245,245,362,245,245,362,245,245
,362,362,245,245,245,245,245,245,245,362,362,245,245,362,245,37,245,245
,37,245,362,37,362,362,362,362,362,37,37,362,362,37,37,37,362,362,362,362
,37,362,362,37,362,37,37,37,37,362,362,37,37,362,362,362,362,37,37,37,37
,362,362,362,362,362,362,37,37,37,362,362,362,362,37,362,362,37,37,37,37
,37,37,37,362,37,37,37,37,37,37,362,362,362,362,362,362,362,362,362,362
,37,37,37,362,37,362,37,362,362,362,362,362,362,362,362,362,37,37,37,362
,37,37,362,362,362,362,362,362,362,362,37,37,37,37,37,362,362,362,362,37
,37,37,37,37,37,362,362,362,37,37,362,362,213,37,213,213,362,362,362,362
,213,362,362,362,362,362,362,362,362,362,213,362,362,362,362,213,213,213
,213,213,213,362,362,362,213,213,362,213,213,362,213,213,213,213,362,362
,362,213,213,213,213,213,362,213,362,362,362,213,213,213,213,362,362,362
,362,362,213,362,362,362,362,213,213,213,362,362,362,213,362,362,213,362
,362,213,362,362,362,213,213,213,362,213,213,362,362,362,362,213,213,213
,362,213,213,362,213,213,362,362,213,213,213,213,213,213,213,362,362,213
,213,362,213,362,213,213,231,213,231,231,362,362,362,362,231,362,362,362
,362,362,362,362,362,362,231,362,362,362,362,231,231,231,231,231,231,362
,362,362,231,231,362,231,231,231,362,231,231,231,362,362,362,231,231,231
,231,231,362,231,362,362,362,231,231,231,231,362,362,362,362,362,362,362
,362,362,362,231,231,231,362,362,362,231,362,362,231,362,362,231,362,362
,362,231,231,231,362,231,231,362,362,362,362,231,231,231,231,231,231,362
,231,231,362,362,231,231,231,231,231,231,231,362,362,231,231,362,231,362
,231,231,217,231,217,217,362,362,362,362,217,362,362,362,362,362,362,362
,362,362,217,362,362,362,362,217,217,217,217,217,217,362,362,362,217,217
,217,217,217,362,362,217,217,217,362,217,362,217,217,217,217,217,362,217
,362,362,362,217,217,217,217,362,362,362,362,362,362,362,362,362,362,217
,217,217,362,362,362,217,362,362,217,362,362,217,362,362,362,217,217,217
,362,217,217,362,362,362,362,217,217,217,362,217,217,362,217,217,362,362
,217,217,217,217,217,217,217,362,362,217,217,362,217,21,217,217,21,217,362
,21,362,362,362,362,362,21,21,362,362,21,21,21,362,362,362,362,21,362,362
,21,362,21,21,21,21,362,362,21,21,362,362,362,362,21,21,21,21,362,362,362
,362,362,362,21,21,21,362,362,362,362,21,362,362,21,21,21,21,21,21,21,362
,21,21,21,21,21,21,362,362,362,362,362,362,362,362,362,362,21,21,21,362
,21,143,21,143,143,362,362,362,362,362,362,143,21,21,21,362,21,21,362,362
,143,362,143,362,143,143,21,21,21,21,21,362,362,362,362,21,21,21,21,21,21
,362,362,362,21,21,143,143,229,21,229,229,362,362,362,362,229,362,362,362
,362,362,362,362,362,362,229,362,362,362,362,229,229,229,229,229,229,362
,362,362,229,229,362,229,229,362,143,229,229,229,362,362,362,229,229,229
,229,229,362,229,362,362,143,229,229,229,229,362,362,143,362,362,362,362
,362,362,362,229,229,229,362,362,362,229,362,362,229,362,362,229,362,362
,362,229,229,229,362,229,229,362,362,362,362,229,229,229,229,229,229,362
,229,229,362,362,229,229,229,229,229,229,229,362,362,229,229,362,229,362
,229,229,247,229,247,247,362,362,362,362,247,362,362,362,362,362,362,362
,362,362,247,362,362,362,362,247,247,247,247,247,247,362,362,362,247,247
,362,247,247,362,362,247,247,247,362,247,362,247,247,247,247,247,362,247
,362,362,362,247,247,247,247,362,362,362,362,362,362,362,362,362,362,247
,247,247,362,362,362,247,362,362,247,362,362,247,362,362,362,247,247,247
,362,247,247,362,362,362,362,247,247,247,362,247,247,362,247,247,362,362
,247,247,247,247,247,247,247,362,362,247,247,362,247,362,247,247,276,247
,276,276,362,362,362,362,276,362,362,362,362,362,362,362,362,362,276,362
,362,362,362,276,276,276,276,276,276,362,362,362,276,276,362,276,276,362
,362,276,276,276,362,276,362,276,276,276,276,276,362,276,362,362,362,276
,276,276,276,362,362,362,362,362,362,362,362,362,362,276,276,276,362,362
,362,276,362,362,276,362,362,276,362,362,362,276,276,276,362,276,276,362
,362,362,362,276,276,276,362,276,276,362,276,276,362,362,276,276,276,276
,276,276,276,362,362,276,276,362,276,362,276,276,279,276,279,279,362,362
,362,362,279,362,362,362,362,362,362,362,362,362,279,362,362,362,362,279
,279,279,279,279,279,362,362,362,279,279,362,279,279,362,362,279,279,279
,362,279,362,279,279,279,279,279,362,279,362,362,362,279,279,279,279,362
,362,362,362,362,362,362,362,362,362,279,279,279,362,362,362,279,362,362
,279,362,362,279,362,362,362,279,279,279,362,279,279,362,362,362,362,279
,279,279,362,279,279,362,279,279,362,362,279,279,279,279,279,279,279,362
,362,279,279,362,279,362,279,279,283,279,283,283,362,362,362,362,283,362
,362,362,362,362,362,362,362,362,283,362,362,362,362,283,283,283,283,283
,283,362,362,362,283,283,362,283,283,362,362,283,283,283,362,283,362,283
,283,283,283,283,362,283,362,362,362,283,283,283,283,362,362,362,362,362
,362,362,362,362,362,283,283,283,362,362,362,283,362,362,283,362,362,283
,362,362,362,283,283,283,362,283,283,362,362,362,362,283,283,283,362,283
,283,362,283,283,362,362,283,283,283,283,283,283,283,362,362,283,283,362
,283,362,283,283,251,283,251,251,362,362,362,362,251,362,362,362,362,362
,362,362,362,362,251,362,362,362,362,251,251,251,251,251,251,362,362,362
,251,251,362,251,251,362,362,251,251,251,362,362,362,251,251,251,251,251
,362,251,362,362,362,251,251,251,251,362,362,362,362,362,362,362,362,362
,362,251,251,251,362,362,362,251,362,362,251,362,362,251,362,362,362,251
,251,251,362,251,251,362,362,362,362,251,251,251,362,251,251,362,251,251
,362,362,251,251,251,251,251,251,251,362,362,251,251,362,251,362,251,251
,252,251,252,252,362,362,362,362,252,362,362,362,362,362,362,362,362,362
,252,362,362,362,362,252,252,252,252,252,252,362,362,362,252,252,362,252
,252,362,362,252,252,252,362,362,362,252,252,252,252,252,362,252,362,362
,362,252,252,252,252,362,362,362,362,362,362,362,362,362,362,252,252,252
,362,362,362,252,362,362,252,362,362,252,362,362,362,252,252,252,362,252
,252,362,362,362,362,252,252,252,362,252,252,362,252,252,362,362,252,252
,252,252,252,252,252,362,362,252,252,362,252,362,252,252,259,252,259,259
,362,362,362,362,259,362,362,362,362,362,362,362,362,362,259,362,362,362
,362,259,259,259,259,259,259,362,362,362,259,259,362,259,259,362,362,259
,259,259,362,362,362,259,259,259,259,259,362,259,362,362,362,259,259,259
,259,362,362,362,362,362,362,362,362,362,362,259,259,259,362,362,362,259
,362,362,259,362,362,259,362,362,362,259,259,259,362,259,259,362,362,362
,362,259,259,259,362,259,259,362,259,259,362,362,259,259,259,259,259,259
,259,362,362,259,259,362,259,362,259,259,261,259,261,261,362,362,362,362
,261,362,362,362,362,362,362,362,362,362,261,362,362,362,362,261,261,261
,261,261,261,362,362,362,261,261,362,261,261,362,362,261,261,261,362,362
,362,261,261,261,261,261,362,261,362,362,362,261,261,261,261,362,362,362
,362,362,362,362,362,362,362,261,261,261,362,362,362,261,362,362,261,362
,362,261,362,362,362,261,261,261,362,261,261,362,362,362,362,261,261,261
,362,261,261,362,261,261,362,362,261,261,261,261,261,261,261,362,362,261
,261,362,261,362,261,261,263,261,263,263,362,362,362,362,263,362,362,362
,362,362,362,362,362,362,263,362,362,362,362,263,263,263,263,263,263,362
,362,362,263,263,362,263,263,362,362,263,263,263,362,362,362,263,263,263
,263,263,362,263,362,362,362,263,263,263,263,362,362,362,362,362,362,362
,362,362,362,263,263,263,362,362,362,263,362,362,263,362,362,263,362,362
,362,263,263,263,362,263,263,362,362,362,362,263,263,263,362,263,263,362
,263,263,362,362,263,263,263,263,263,263,263,362,362,263,263,362,263,362
,263,263,218,263,218,218,362,362,362,362,218,362,362,362,362,362,362,362
,362,362,218,362,362,362,362,218,218,218,218,218,218,362,362,362,218,218
,362,218,218,362,362,218,218,218,362,362,362,218,218,218,218,218,362,218
,362,362,362,218,218,218,218,362,362,362,362,362,362,362,362,362,362,218
,218,218,362,362,362,218,362,362,218,362,362,218,362,362,362,218,218,218
,362,218,218,362,362,362,362,218,218,218,362,218,218,362,218,218,362,362
,218,218,218,218,218,218,218,362,362,218,218,362,218,362,218,218,249,218
,249,249,362,362,362,362,249,362,362,362,362,362,362,362,362,362,249,362
,362,362,362,249,249,249,249,249,249,362,362,362,249,249,362,249,249,362
,362,249,249,249,362,362,362,249,249,249,249,249,362,249,362,362,362,249
,249,249,249,362,362,362,362,362,362,362,362,362,362,249,249,249,362,362
,362,249,362,362,249,362,362,249,362,362,362,249,249,249,362,249,249,362
,362,362,362,249,249,249,362,249,249,362,249,249,362,362,249,249,249,249
,249,249,249,362,362,249,249,362,249,362,249,249,250,249,250,250,362,362
,362,362,250,362,362,362,362,362,362,362,362,362,250,362,362,362,362,250
,250,250,250,250,250,362,362,362,250,250,362,250,250,362,362,250,250,250
,362,362,362,250,250,250,250,250,362,250,362,362,362,250,250,250,250,362
,362,362,362,362,362,362,362,362,362,250,250,250,362,362,362,250,362,362
,250,362,362,250,362,362,362,250,250,250,362,250,250,362,362,362,362,250
,250,250,362,250,250,362,250,250,362,362,250,250,250,250,250,250,250,362
,362,250,250,170,250,362,250,250,362,250,362,362,170,170,362,170,362,170
,170,362,362,362,362,170,362,362,362,362,170,170,170,170,362,170,170,362
,170,362,170,170,170,170,170,170,362,362,362,362,362,362,170,170,170,362
,362,362,362,362,362,362,170,170,170,170,170,362,170,362,362,362,170,170
,170,170,362,362,362,362,362,362,362,362,362,362,170,170,170,362,362,362
,170,362,362,362,362,362,362,362,362,362,170,170,170,362,170,170,362,362
,362,362,362,362,362,362,170,170,170,170,170,362,167,362,362,170,170,170
,170,170,170,167,167,362,167,170,167,167,362,362,362,362,167,362,362,362
,362,167,167,167,167,362,167,167,362,167,362,167,167,167,167,167,167,362
,362,362,362,362,362,167,167,167,362,362,362,362,362,362,362,167,167,167
,167,167,362,167,362,362,362,167,167,167,167,362,362,362,362,362,362,362
,362,362,362,167,167,167,362,362,362,167,362,362,362,362,362,362,362,362
,362,167,167,167,362,167,167,362,362,336,362,362,362,362,362,167,167,167
,167,167,362,362,362,362,167,167,167,167,167,167,362,336,362,362,167,336
,336,362,362,336,362,362,362,362,336,362,362,336,362,336,362,362,336,336
,336,336,362,362,362,336,362,336,336,336,362,362,362,362,362,362,362,362
,362,362,336,336,336,362,336,362,362,336,336,336,336,336,362,362,336,336
,336,362,362,362,362,362,336,336,336,336,362,362,336,336,336,362,362,336
,336,336,362,362,362,336,336,362,336,336,362,362,362,336,362,362,362,362
,336,336,362,336,336,362,336,362,362,362,336,336,336,336,362,336,219,219
,362,336,219,362,163,362,219,362,362,362,362,219,362,163,163,362,163,362
,163,163,219,362,362,362,219,219,362,362,219,163,163,163,163,362,163,163
,362,163,362,163,163,219,219,219,219,219,219,219,362,362,362,219,219,163
,362,362,362,362,362,362,362,163,163,219,219,219,362,219,362,362,219,219
,219,219,219,219,362,362,362,362,362,362,219,362,362,219,219,219,219,362
,362,219,219,362,362,362,362,219,219,362,362,163,219,219,362,219,219,219
,362,197,362,362,362,362,362,219,219,163,219,219,219,362,362,362,163,219
,219,219,219,163,219,197,362,362,219,197,197,362,362,197,362,362,362,362
,197,362,362,362,362,197,362,362,197,197,197,197,362,362,362,197,362,197
,197,197,362,362,362,362,362,362,362,362,362,362,197,197,197,362,197,362
,362,197,197,197,197,197,362,362,197,197,197,362,362,362,362,362,197,197
,197,197,362,362,197,197,197,362,362,197,197,197,362,204,362,197,197,362
,197,197,362,362,362,197,362,362,362,362,197,197,36,197,197,362,197,362
,36,362,197,197,197,197,362,197,362,204,36,197,362,362,204,362,362,36,362
,362,36,362,362,362,204,362,204,362,362,36,362,362,362,362,36,36,36,36,362
,362,362,362,362,362,36,36,36,362,362,362,362,36,362,204,204,204,36,36,36
,36,36,362,36,36,36,36,36,36,362,204,362,362,204,362,362,362,362,362,36
,36,36,362,36,362,36,362,204,362,362,362,362,362,362,362,362,36,36,204,36
,36,362,362,362,362,362,362,312,19,36,36,362,36,36,19,362,362,362,362,36
,36,36,36,362,19,362,362,36,36,362,362,19,36,362,19,362,362,362,362,312
,362,362,362,19,312,362,362,362,19,19,19,19,362,362,312,362,312,362,19,19
,19,362,362,362,362,19,362,362,362,362,19,19,19,19,19,362,19,19,19,19,19
,19,362,312,312,312,362,362,362,362,362,362,19,19,19,362,19,362,19,312,362
,362,312,362,362,362,362,362,362,19,19,362,19,19,362,362,312,362,362,362
,362,362,19,19,362,19,19,312,362,316,362,362,19,19,19,19,362,362,316,316
,19,19,362,316,362,19,316,316,316,316,362,362,362,316,362,316,316,316,362
,362,362,362,362,362,362,362,362,362,316,316,316,362,316,362,362,362,316
,316,316,316,362,362,316,316,316,362,362,362,362,362,316,316,316,362,362
,362,316,362,316,362,362,316,362,362,362,362,362,316,316,362,316,316,362
,362,362,316,233,362,362,362,316,316,362,316,316,362,316,362,362,362,316
,316,316,316,233,362,233,233,233,316,362,362,215,233,362,362,233,362,362
,362,362,362,233,233,362,362,362,233,233,215,215,215,215,362,362,362,233
,233,362,215,215,233,362,233,233,233,362,362,362,233,233,215,215,215,362
,215,362,362,233,215,215,215,215,362,215,362,362,362,362,362,233,215,362
,215,215,215,233,362,362,215,233,362,233,362,362,233,233,362,233,233,215
,215,362,215,215,362,215,362,362,233,233,233,233,215,215,362,215,215,267
,362,233,233,233,215,215,215,215,362,233,233,233,362,215,362,233,233,267
,233,267,267,267,362,362,362,362,267,362,362,267,362,362,362,362,362,267
,267,362,362,362,267,267,362,362,362,328,362,362,328,267,267,362,362,328
,362,362,267,267,267,362,362,362,267,267,362,362,362,328,362,362,362,267
,328,362,362,328,362,362,362,362,362,362,362,362,362,362,362,362,362,267
,362,362,362,267,362,267,362,362,267,267,254,362,267,254,362,362,362,362
,362,362,362,362,267,267,267,362,362,328,254,362,254,254,254,267,267,267
,362,254,328,362,254,267,267,267,362,328,254,267,267,328,267,254,254,362
,328,328,362,362,362,362,254,254,362,362,362,362,362,254,254,254,171,362
,362,254,254,362,362,362,362,171,171,362,254,362,171,171,362,328,362,362
,362,362,362,362,362,171,171,171,171,362,254,362,362,171,254,362,254,362
,362,254,254,362,362,254,362,362,362,362,362,362,362,362,362,254,254,254
,362,171,171,362,362,362,362,362,254,254,254,183,362,362,362,362,254,254
,254,362,362,183,254,254,362,254,362,362,183,183,183,183,362,362,362,362
,362,362,183,183,183,171,362,362,362,362,362,362,362,362,183,183,183,362
,183,362,362,171,183,183,183,183,362,362,171,362,362,362,362,171,362,362
,183,183,183,362,362,183,183,362,362,362,362,362,362,362,362,362,362,183
,183,187,183,183,362,362,362,362,362,362,362,187,183,183,362,183,183,362
,187,187,187,187,183,183,183,183,362,362,187,187,187,183,362,362,362,362
,362,362,362,362,187,187,187,362,187,362,362,362,187,187,187,187,362,362
,362,362,362,362,362,362,362,362,187,187,187,362,362,187,187,362,362,362
,362,362,362,362,362,362,362,187,187,153,187,187,362,362,362,362,362,362
,362,153,187,187,362,187,187,362,153,153,153,153,187,187,187,187,362,362
,153,153,153,187,362,362,362,362,362,362,362,362,153,153,153,362,153,362
,362,41,153,153,153,153,362,362,362,362,362,362,362,362,362,362,153,153
,153,362,362,153,153,41,362,362,362,362,41,362,362,41,362,153,153,275,153
,153,41,362,362,362,362,362,362,362,153,153,362,153,153,362,275,275,275
,275,153,153,153,153,362,362,275,275,362,153,362,362,362,362,362,275,362
,41,275,275,275,362,275,362,362,362,275,275,275,275,362,362,362,362,362
,41,362,362,275,41,275,275,275,362,41,41,275,362,362,362,362,362,362,362
,362,362,362,275,275,362,275,275,362,362,362,362,362,362,362,208,275,275
,362,275,275,362,362,41,362,362,275,275,275,275,208,362,208,208,362,275
,362,362,278,362,362,278,362,362,362,362,362,362,208,362,362,362,362,208
,208,278,278,278,278,362,362,362,208,208,362,278,278,208,362,208,208,208
,362,362,362,208,208,278,278,278,362,278,362,362,362,278,278,278,278,362
,362,362,362,362,362,362,362,362,362,278,278,278,362,362,362,278,362,362
,208,362,362,208,208,208,208,208,278,278,362,278,278,362,7,362,362,208,208
,208,208,278,278,362,278,278,362,362,208,208,208,278,278,278,278,362,362
,208,208,362,278,7,208,208,362,208,362,362,362,362,362,362,362,362,362,362
,362,362,7,7,7,7,362,362,362,362,362,362,7,7,362,362,362,362,362,362,362
,362,362,362,7,7,7,362,7,362,362,362,7,7,7,7,362,362,362,362,362,362,362
,362,362,362,7,7,7,362,362,362,7,362,362,362,362,362,362,362,362,362,362
,7,7,282,7,7,282,362,362,362,362,362,362,362,7,7,362,7,7,362,282,282,282
,282,7,7,7,7,362,362,282,282,362,7,362,362,362,362,362,362,362,362,282,282
,282,362,282,362,362,362,282,282,282,282,362,362,362,362,362,362,362,362
,362,362,282,282,282,362,362,362,282,362,362,362,362,362,362,362,362,362
,362,282,282,146,282,282,362,362,362,362,362,362,362,146,282,282,362,282
,282,362,146,146,146,146,282,282,282,282,362,362,146,146,362,282,362,362
,362,362,362,362,362,362,146,146,146,362,146,362,362,362,146,146,146,146
,362,362,362,362,362,362,362,362,362,362,146,146,146,362,362,362,146,362
,362,362,362,362,362,362,362,362,362,146,146,159,146,146,362,362,362,362
,362,362,362,159,146,146,362,146,146,362,159,159,159,159,146,146,146,146
,362,362,159,159,362,146,362,362,362,362,362,362,362,362,159,159,159,362
,159,362,362,362,159,159,159,159,362,362,6,362,362,362,362,362,362,362,159
,159,159,362,362,362,159,362,362,362,362,362,362,362,362,362,362,159,159
,6,159,159,362,362,362,362,362,362,362,362,159,159,362,159,159,362,6,6,6
,6,159,159,159,159,362,362,6,6,362,159,362,362,362,362,362,362,362,362,6
,6,6,362,6,362,362,362,6,6,6,6,362,362,362,362,362,362,362,362,362,362,6
,6,6,362,362,362,6,362,362,362,362,362,362,362,362,362,362,6,6,352,6,6,362
,362,362,362,362,362,362,352,6,6,362,6,6,362,352,352,352,352,6,6,6,6,362
,362,352,352,362,6,362,362,362,362,362,362,362,362,352,352,352,362,352,362
,362,362,352,352,352,352,362,362,362,362,362,362,362,362,362,362,352,352
,352,362,362,362,352,362,362,362,362,362,362,362,362,362,362,352,352,258
,352,352,362,362,362,362,362,362,362,362,352,352,362,352,352,362,258,258
,258,258,352,352,352,352,362,362,258,258,362,352,362,362,362,362,362,362
,362,362,258,258,258,362,258,362,362,362,258,258,258,258,362,362,362,362
,362,362,362,362,362,362,258,258,258,362,362,362,258,362,362,362,362,362
,362,362,362,362,362,258,258,158,258,258,362,362,362,362,362,362,362,362
,258,258,362,258,258,362,158,158,158,158,258,258,258,258,362,362,158,158
,362,258,362,362,362,362,362,362,362,362,158,158,158,362,158,362,362,362
,158,158,158,158,362,362,362,362,362,362,362,362,362,362,158,158,158,362
,362,362,158,362,362,362,362,362,362,362,362,362,362,158,158,260,158,158
,362,362,362,362,362,362,362,362,158,158,362,158,158,362,260,260,260,260
,158,158,158,158,362,362,260,260,362,158,362,362,362,362,362,362,362,362
,260,260,260,362,260,362,362,362,260,260,260,260,362,362,362,362,362,362
,362,362,362,362,260,260,260,362,362,362,260,362,362,362,362,362,362,362
,362,362,362,260,260,230,260,260,362,362,362,362,362,362,362,362,260,260
,362,260,260,362,230,230,230,230,260,260,260,260,362,362,230,230,362,260
,362,362,362,362,362,362,362,362,230,230,230,362,230,362,362,362,230,230
,230,230,362,362,362,362,362,362,362,362,362,362,230,230,230,362,362,362
,230,362,362,362,362,362,362,362,362,362,362,230,230,262,230,230,362,362
,362,362,362,362,362,362,230,230,362,230,230,362,262,262,262,262,230,230
,230,230,362,362,262,262,362,230,362,362,362,362,362,362,362,362,262,262
,262,362,262,362,362,362,262,262,262,262,362,362,362,362,362,362,362,362
,362,362,262,262,262,362,362,362,262,362,362,362,362,362,362,362,362,362
,362,262,262,182,262,262,362,362,362,362,362,362,362,362,262,262,362,262
,262,362,182,182,182,182,262,262,262,262,362,362,182,182,362,262,362,362
,362,362,362,362,362,362,182,182,182,362,182,362,362,362,182,182,182,182
,362,362,362,362,362,362,362,362,362,362,182,182,182,362,362,362,182,362
,362,362,362,362,362,362,362,362,362,182,182,216,182,182,362,362,362,362
,362,362,362,362,182,182,362,182,182,362,216,216,216,216,182,182,182,182
,362,362,216,216,362,182,362,362,362,362,362,362,362,362,216,216,216,362
,216,362,362,362,216,216,216,216,362,362,362,362,362,362,362,362,362,362
,216,216,216,362,362,362,216,362,362,362,362,362,362,362,362,362,362,216
,216,235,216,216,362,362,362,362,362,362,362,362,216,216,362,216,216,362
,235,235,235,235,216,216,216,216,362,362,235,235,362,216,362,362,362,362
,362,362,362,362,235,235,235,362,235,362,362,362,235,235,235,235,362,362
,362,362,362,362,362,362,362,362,235,235,235,362,362,362,235,362,362,362
,362,362,362,362,362,362,362,235,235,152,235,235,362,362,362,362,362,362
,362,362,235,235,362,235,235,362,152,152,152,152,235,235,235,235,362,362
,152,152,362,235,362,362,362,362,362,362,362,362,152,152,152,362,152,362
,362,362,152,152,152,152,362,362,362,362,362,362,362,362,362,362,152,152
,152,362,362,362,152,362,362,362,362,362,362,362,362,362,362,152,152,186
,152,152,362,362,362,362,362,362,362,362,152,152,362,152,152,362,186,186
,186,186,152,152,152,152,362,362,186,186,362,152,362,362,362,362,362,362
,362,362,186,186,186,362,186,362,362,362,186,186,186,186,362,362,362,362
,362,362,362,362,362,362,186,186,186,362,362,362,186,362,362,362,362,362
,362,362,362,362,362,186,186,166,186,186,362,362,362,362,362,362,362,362
,186,186,362,186,186,362,166,166,166,166,186,186,186,186,362,362,166,166
,362,186,362,362,362,362,362,362,362,362,166,166,166,362,166,362,362,362
,166,166,166,166,362,362,362,362,362,362,362,362,362,362,166,166,166,362
,362,362,166,362,362,362,362,362,362,362,362,362,362,166,166,196,166,166
,362,362,362,362,362,362,362,362,166,166,362,166,166,362,196,196,196,196
,166,166,166,166,362,362,196,196,362,166,362,362,362,362,362,362,362,362
,196,196,196,362,196,362,362,362,196,196,196,196,362,362,362,362,362,362
,362,362,362,362,196,196,196,362,362,362,196,362,362,362,362,362,362,362
,362,362,362,196,196,224,196,196,362,362,362,362,362,362,362,362,196,196
,362,196,196,362,224,224,224,224,196,196,196,196,362,362,224,224,362,196
,362,362,362,362,362,362,362,362,224,224,224,362,224,362,362,362,224,224
,224,224,362,362,362,362,362,362,362,362,362,362,224,224,224,362,362,362
,224,362,362,362,362,362,362,362,362,362,362,224,224,315,224,224,362,362
,362,362,362,362,362,362,224,224,362,224,224,362,315,315,315,315,224,224
,224,224,362,362,315,315,362,224,362,362,362,362,362,362,362,362,315,315
,315,362,315,362,362,362,315,315,315,315,362,362,362,362,362,362,362,362
,362,362,315,315,315,362,362,362,315,362,362,362,362,362,362,362,362,362
,362,315,315,145,315,315,362,362,362,362,362,362,362,362,315,315,362,315
,315,362,145,145,145,145,315,315,315,315,362,362,145,145,362,315,362,362
,362,362,362,362,362,362,145,145,145,362,145,362,362,362,145,145,145,145
,362,362,362,362,362,362,362,362,362,362,145,145,145,362,362,362,145,362
,362,362,362,362,362,362,362,362,362,145,145,335,145,145,362,362,362,362
,362,362,362,362,145,145,362,145,145,362,335,335,335,335,145,145,145,145
,362,362,335,335,362,145,362,362,362,362,362,362,362,362,335,335,335,362
,335,362,362,362,335,335,335,335,362,362,362,362,362,362,362,362,362,362
,335,335,335,362,362,362,335,362,362,362,362,362,362,362,362,362,362,335
,335,169,335,335,362,362,362,362,362,362,362,362,335,335,362,335,335,362
,169,169,169,169,335,335,335,335,362,362,169,169,362,335,362,362,362,362
,362,362,362,362,169,169,169,362,169,362,362,362,169,169,169,169,362,362
,362,362,362,362,362,362,362,362,169,169,169,362,362,362,169,362,362,362
,362,362,362,362,362,362,362,169,169,351,169,169,362,362,362,362,362,362
,362,362,169,169,362,169,169,362,351,351,351,351,169,169,169,169,362,362
,351,351,362,169,362,362,362,362,362,362,362,362,351,351,351,362,351,362
,362,362,351,351,351,351,362,362,362,362,362,362,362,362,362,362,351,351
,351,362,362,362,351,362,362,362,362,362,362,362,362,362,362,351,351,228
,351,351,362,362,362,362,362,362,362,362,351,351,362,351,351,362,228,228
,228,228,351,351,351,351,362,362,228,228,362,351,362,362,362,362,362,362
,362,362,228,228,228,362,228,362,362,362,228,228,228,228,362,362,237,237
,362,237,237,362,362,362,228,228,228,362,362,237,228,362,362,362,362,362
,362,362,237,362,362,228,228,237,228,228,237,362,362,362,362,362,362,362
,228,228,362,228,228,209,362,209,209,362,228,228,228,228,362,362,237,237
,362,228,362,362,237,209,362,362,362,362,209,209,362,362,362,362,237,362
,362,209,209,362,362,362,209,362,209,209,209,362,362,362,209,209,237,362
,362,362,237,362,362,362,362,237,237,362,362,362,362,362,362,362,362,362
,362,362,362,362,362,362,362,362,362,362,362,209,362,362,209,362,209,209
,209,362,362,362,237,362,362,362,362,362,209,209,209,209,362,362,362,362
,362,362,362,209,209,209,221,362,221,221,362,362,209,209,362,362,362,209
,209,362,209,362,362,362,221,362,221,362,362,221,221,362,362,362,362,362
,362,362,221,221,221,362,362,362,221,221,221,221,362,221,362,221,221,210
,362,210,210,362,362,362,362,362,362,362,362,362,362,362,362,362,362,210
,362,362,362,362,210,210,362,362,362,362,362,362,221,210,210,221,362,362
,210,221,210,210,210,362,362,362,210,210,362,221,221,221,362,362,362,362
,362,362,362,362,221,221,221,362,362,362,362,362,362,221,221,256,256,362
,221,221,362,221,362,210,362,362,210,362,362,210,210,256,362,256,256,362
,362,362,362,362,210,210,210,210,362,362,362,362,362,256,362,210,210,210
,256,256,362,362,362,362,210,210,362,256,256,210,210,362,210,362,256,256
,256,362,362,362,256,256,362,362,362,362,362,362,362,362,362,362,362,362
,362,362,362,362,362,118,118,362,362,118,362,362,362,118,362,362,362,362
,118,256,362,362,256,362,362,362,256,118,362,362,362,362,118,362,362,118
,256,256,256,362,362,362,362,362,362,362,362,256,256,256,362,362,118,118
,118,362,256,256,362,118,362,256,256,362,256,362,362,362,362,362,362,362
,362,118,362,118,118,118,362,362,362,362,118,246,362,246,246,362,362,118
,362,362,362,362,362,118,118,362,118,118,362,246,362,362,118,118,246,246
,362,362,362,362,362,362,118,246,246,362,362,362,362,246,246,246,246,362
,246,118,246,246,362,362,362,362,362,359,359,118,359,362,118,362,362,362
,362,118,362,362,362,362,362,362,362,362,362,362,362,359,362,362,362,246
,359,362,246,359,362,362,246,362,362,362,362,362,362,362,362,362,246,246
,246,362,362,362,362,362,362,362,362,246,246,246,362,362,362,362,362,362
,246,246,227,362,227,246,246,227,246,359,362,227,362,227,227,227,227,227
,362,227,362,227,227,362,362,362,362,359,362,362,227,359,227,227,227,227
,359,359,227,227,227,362,227,227,211,362,211,211,362,362,362,362,362,362
,362,362,227,362,362,362,362,362,211,362,227,227,362,211,211,359,362,362
,232,362,362,362,211,211,362,362,362,211,362,211,211,211,362,362,362,211
,211,362,362,362,232,362,362,362,362,232,362,362,232,362,227,362,362,362
,362,232,362,362,362,362,362,362,362,362,362,362,227,362,211,362,362,211
,362,227,362,211,305,362,227,362,362,362,362,362,362,211,211,211,211,362
,232,305,362,305,305,362,211,211,211,362,362,362,232,362,362,211,211,362
,232,305,211,211,232,211,305,305,362,232,232,362,362,362,362,305,305,362
,362,362,362,362,305,305,305,362,362,362,305,305,307,362,307,307,362,362
,362,362,362,362,362,362,232,362,362,362,362,362,307,362,362,307,362,307
,307,362,362,362,362,362,362,305,307,307,305,362,362,362,305,307,307,307
,362,362,362,307,307,362,305,305,305,362,362,362,362,362,362,362,362,305
,305,305,362,362,362,362,362,362,305,305,362,362,362,305,305,362,305,362
,307,362,362,307,362,362,362,307,214,362,214,214,362,362,362,362,362,307
,307,307,362,362,362,362,362,362,214,362,307,307,307,214,214,362,362,362
,362,307,307,362,214,214,307,307,362,307,214,214,214,214,362,362,205,214
,214,362,362,362,362,362,362,362,362,362,362,362,362,205,362,205,205,362
,362,362,362,362,362,362,362,362,362,362,362,362,362,205,214,362,362,214
,205,205,362,214,362,362,362,362,362,205,205,362,362,214,214,214,205,205
,205,362,362,362,205,205,214,214,214,362,362,350,362,362,362,214,214,362
,362,339,214,214,339,214,362,362,362,339,362,339,339,362,362,362,362,362
,362,205,362,362,205,339,362,350,205,362,339,362,350,339,362,362,362,362
,205,205,205,362,350,362,350,362,362,362,362,205,205,205,119,119,362,362
,119,362,205,205,119,362,362,205,205,119,205,362,362,362,362,350,350,350
,119,339,362,362,362,119,362,318,119,362,362,362,339,350,362,362,350,362
,362,339,362,362,362,339,362,119,119,119,339,339,350,362,119,362,212,362
,212,212,362,318,362,350,362,362,318,362,119,362,362,119,119,362,212,362
,318,119,318,212,212,362,362,339,119,362,362,362,212,212,119,119,362,119
,119,212,212,212,362,119,119,212,212,362,362,318,318,318,362,119,362,362
,362,362,362,362,362,362,362,362,362,318,119,362,318,362,362,362,362,362
,362,362,119,362,212,119,362,212,318,362,119,212,362,362,362,362,362,362
,362,318,362,212,212,212,212,362,362,344,362,344,344,362,212,212,212,362
,362,362,362,362,362,212,212,362,362,344,212,212,344,212,344,344,362,362
,362,362,362,362,362,344,344,362,362,362,362,362,344,344,344,362,362,362
,344,344,199,362,199,199,362,362,362,362,362,362,362,362,362,362,362,362
,362,362,199,362,362,199,362,199,199,362,362,362,362,362,362,344,199,199
,344,362,362,362,344,199,199,199,362,362,362,199,199,362,344,344,344,362
,362,362,362,362,362,362,362,344,344,344,362,362,362,362,362,362,344,344
,362,362,362,344,344,362,344,362,199,362,362,199,362,362,362,199,274,362
,274,274,362,362,362,362,362,199,199,199,362,362,362,362,362,362,274,362
,199,199,199,274,274,362,362,362,362,199,199,362,274,274,199,199,362,199
,362,274,274,274,362,274,362,274,274,309,362,309,309,362,362,362,362,362
,362,362,362,362,362,362,362,362,362,309,362,362,362,362,309,309,362,362
,362,362,362,362,274,309,309,274,362,362,362,274,309,309,309,362,362,362
,309,309,362,274,274,274,362,362,362,362,362,362,362,362,274,274,274,362
,362,362,362,362,362,274,274,362,362,362,274,274,362,274,362,309,362,362
,309,362,362,362,309,201,362,201,201,362,362,362,362,362,309,309,309,362
,362,362,362,362,362,201,362,309,309,309,201,201,362,362,362,362,309,309
,362,201,201,309,309,362,309,362,201,201,201,362,362,362,201,201,345,362
,345,345,362,362,362,362,362,362,362,362,362,362,362,362,362,362,345,362
,362,362,362,345,345,362,362,362,362,362,362,201,345,345,201,362,362,362
,201,345,345,345,362,362,362,345,345,362,201,201,201,362,362,362,362,362
,362,362,362,201,201,201,362,362,362,362,362,362,201,201,362,362,362,201
,201,362,201,362,345,362,362,345,362,362,362,345,346,362,346,346,362,362
,362,362,362,345,345,345,362,362,362,362,362,362,346,362,345,345,345,346
,346,362,362,362,362,345,345,362,346,346,345,345,362,345,362,346,346,346
,362,362,362,346,346,200,362,200,200,362,362,362,362,362,362,362,362,362
,362,362,362,362,362,200,362,362,362,362,200,200,362,362,362,362,362,362
,346,200,200,346,362,362,362,346,200,200,200,362,362,362,200,200,362,346
,346,346,362,362,362,362,362,362,362,362,346,346,346,362,362,362,362,362
,362,346,346,362,362,362,346,346,362,346,362,200,362,362,200,362,362,362
,200,308,362,308,308,362,362,362,362,362,200,200,200,362,362,362,362,362
,362,308,362,200,200,200,308,308,362,362,362,362,200,200,362,308,308,200
,200,362,200,362,308,308,308,362,362,362,308,308,362,362,362,362,362,362
,342,362,362,362,362,362,362,362,362,362,362,15,15,362,362,15,362,362,362
,15,362,362,342,362,15,308,362,342,308,362,342,362,308,15,15,15,362,362
,15,362,362,15,308,308,308,362,15,362,362,362,362,362,362,308,308,308,362
,362,15,15,15,362,308,308,362,15,362,308,308,362,308,362,342,362,362,362
,65,65,362,342,65,362,362,15,65,362,362,362,15,65,342,362,362,362,342,15
,362,362,65,342,342,15,362,65,15,15,65,362,362,362,15,15,362,362,362,362
,362,362,362,362,15,362,362,65,65,65,362,362,362,362,65,362,342,15,16,16
,362,362,16,362,362,362,16,15,362,362,362,16,65,362,362,362,362,65,362,362
,16,362,362,362,65,16,362,362,16,362,65,362,362,65,65,362,362,362,362,65
,65,362,362,362,362,16,16,16,362,65,362,362,16,362,362,362,113,113,362,362
,113,362,65,362,113,362,362,362,362,113,16,362,65,362,362,16,362,362,113
,362,362,362,16,113,362,362,113,362,16,362,362,16,16,362,362,362,362,16
,16,362,362,362,362,113,113,113,362,16,362,362,113,362,362,362,20,20,362
,362,20,362,16,362,20,362,362,362,362,20,113,362,16,362,362,113,362,362
,20,362,362,362,113,20,362,362,20,362,113,362,362,113,113,362,362,362,362
,113,113,362,362,362,362,20,20,20,362,113,362,362,20,362,362,362,34,34,362
,362,34,362,113,362,34,362,362,362,362,34,20,362,113,362,362,20,362,362
,34,362,362,362,20,34,362,362,34,362,20,362,362,20,20,362,362,362,362,20
,20,362,362,362,362,34,34,34,362,20,362,362,34,362,362,362,277,277,362,362
,277,362,20,362,277,362,362,362,362,277,34,362,20,362,362,34,362,362,277
,362,362,362,34,277,362,362,277,362,34,362,362,34,34,362,362,362,362,34
,34,362,362,362,362,277,277,277,362,34,362,362,277,362,362,362,122,122,362
,362,122,362,34,362,122,362,362,362,362,122,277,362,34,362,362,277,362,362
,122,362,362,362,277,122,362,362,122,362,277,362,362,277,277,362,362,362
,362,277,277,362,362,362,362,122,122,122,362,277,362,362,122,362,362,362
,125,125,362,362,125,362,277,362,125,362,362,362,362,125,122,362,277,362
,362,122,362,362,125,362,362,362,122,125,362,362,125,362,122,362,362,122
,122,362,362,362,362,122,122,362,362,362,362,125,125,125,362,122,362,362
,125,362,362,362,281,281,362,362,281,362,122,362,281,362,362,362,362,281
,125,362,122,362,362,125,362,362,281,362,362,362,125,281,362,362,281,362
,125,362,362,125,125,362,362,362,362,125,125,362,362,362,362,281,281,281
,362,125,362,362,281,362,362,362,131,131,362,362,131,362,125,362,131,362
,362,362,362,131,281,362,125,362,362,281,362,362,131,362,362,362,281,131
,362,362,131,362,281,362,362,281,281,362,362,362,362,281,281,362,362,362
,362,131,131,131,362,281,362,362,131,362,362,362,173,173,362,362,173,362
,281,362,173,362,362,362,362,173,131,362,281,362,362,131,362,362,173,362
,362,362,131,173,362,362,173,362,131,362,362,131,131,362,362,362,362,131
,131,362,362,362,362,173,173,173,362,131,362,362,173,362,362,362,175,175
,362,362,175,362,131,362,175,362,362,362,362,175,173,362,131,362,362,173
,362,362,175,362,362,362,173,175,362,362,175,362,173,362,362,173,173,362
,362,362,362,173,173,362,362,362,362,175,175,175,362,173,362,362,175,362
,362,362,177,177,362,362,177,362,173,362,177,362,362,362,362,177,175,362
,173,362,362,175,362,362,177,362,362,362,175,177,362,362,177,362,175,362
,362,175,175,362,362,362,362,175,175,362,362,362,362,177,177,177,362,175
,362,362,177,362,362,362,180,180,362,362,180,362,175,362,180,362,362,362
,362,180,177,362,175,362,362,177,362,362,180,362,362,362,177,180,362,362
,180,362,177,362,362,177,177,362,362,362,362,177,177,362,362,362,362,180
,180,180,362,177,362,362,180,362,362,362,140,140,362,362,140,362,177,362
,140,362,362,362,362,140,180,362,177,362,362,180,362,362,140,362,362,362
,180,140,362,362,140,362,180,362,362,180,180,362,362,362,362,180,180,362
,362,362,362,140,140,140,362,180,362,362,140,362,362,362,313,313,362,362
,313,362,180,362,313,362,362,362,362,313,140,362,180,362,362,140,362,362
,313,362,362,362,140,313,362,362,313,362,140,362,362,140,140,362,362,362
,362,140,140,362,362,362,362,313,313,313,362,140,362,362,313,362,362,362
,18,18,362,362,18,362,140,362,18,362,362,362,362,18,313,362,140,362,362
,313,362,362,18,362,362,362,313,18,362,362,18,362,313,362,362,313,313,362
,362,362,362,313,313,362,362,362,362,18,18,18,362,313,362,362,18,362,362
,362,184,184,362,362,184,362,313,362,184,362,362,362,362,184,18,362,313
,362,362,18,362,362,184,362,362,362,18,184,362,362,184,362,18,362,362,18
,18,362,362,362,362,18,18,362,362,362,362,184,184,184,362,18,362,362,184
,362,362,362,61,61,362,362,61,362,18,362,61,362,362,362,362,61,184,362,18
,362,362,184,362,362,61,362,362,362,184,61,362,362,61,362,184,362,362,184
,184,362,362,362,362,184,184,362,362,362,362,61,61,61,362,184,362,362,61
,362,362,362,23,23,362,362,23,362,184,362,23,362,362,362,362,23,61,362,184
,362,362,61,362,362,23,362,362,362,61,23,362,362,23,362,61,362,362,61,61
,362,362,362,362,61,61,362,362,362,362,23,23,23,362,61,362,362,23,362,362
,362,189,189,362,362,189,362,61,362,189,362,362,362,362,189,23,362,61,362
,362,23,362,362,189,362,362,362,23,189,362,362,189,362,23,362,362,23,23
,362,362,362,362,23,23,362,362,362,362,189,189,189,362,23,362,362,189,362
,362,362,222,222,362,362,222,362,23,362,222,362,362,362,362,222,189,362
,23,362,362,189,362,362,222,362,362,362,189,222,362,362,222,362,189,362
,362,189,189,362,362,362,362,189,189,362,362,362,362,222,222,222,362,189
,362,362,222,362,362,362,191,191,362,362,191,362,189,362,191,362,362,362
,362,191,222,362,189,362,362,222,362,362,191,362,362,362,222,191,362,362
,191,362,222,362,362,222,222,362,362,362,362,222,222,362,362,362,362,191
,191,191,362,222,362,362,191,362,348,362,340,348,362,340,362,362,222,362
,340,362,340,340,362,362,191,348,222,362,362,191,348,362,340,362,362,348
,191,340,348,362,340,362,191,348,362,191,191,362,348,362,362,191,191,362
,362,362,362,362,348,362,348,191,362,362,63,63,362,362,63,362,362,362,63
,362,191,362,362,63,362,362,348,362,340,362,191,362,63,348,348,348,362,63
,362,340,63,362,362,362,348,362,340,362,348,348,340,362,348,348,348,340
,340,63,63,63,362,362,362,362,63,362,348,362,150,150,362,362,150,362,362
,362,150,348,362,362,362,150,63,362,362,362,348,63,340,362,150,362,362,362
,63,150,362,362,150,203,63,362,203,63,63,362,362,362,362,63,63,362,362,362
,362,150,150,150,362,63,362,203,150,362,362,362,203,362,362,203,362,362
,63,362,203,362,362,362,362,203,150,362,63,362,362,150,362,362,362,203,362
,203,150,362,292,362,362,292,150,362,362,150,150,362,362,362,362,150,150
,362,362,203,362,362,362,362,292,150,203,203,203,292,362,349,292,362,349
,362,362,203,150,362,362,203,203,362,362,203,203,203,150,362,362,362,362
,349,362,362,362,362,349,203,362,349,362,362,362,362,349,362,362,362,203
,349,362,362,292,362,362,362,362,203,362,349,362,349,362,362,362,311,362
,362,311,362,292,362,362,362,292,362,362,362,362,292,292,349,362,362,362
,362,362,311,349,349,349,362,311,362,362,311,362,362,362,349,311,362,362
,349,349,311,362,349,349,349,362,362,292,362,362,311,362,311,362,362,362
,349,362,362,362,362,362,362,362,362,362,330,349,362,362,362,362,311,362
,362,362,349,362,362,311,311,311,362,362,362,362,362,362,330,362,311,362
,362,330,311,311,330,362,311,311,311,330,362,362,330,362,330,362,362,43
,43,362,311,43,362,362,330,43,330,362,362,362,43,311,362,362,362,362,362
,362,43,43,311,362,362,362,43,362,330,43,362,362,362,362,362,330,330,330
,362,362,362,362,362,362,362,362,330,362,362,362,330,330,362,43,330,330
,330,362,362,362,362,362,362,362,362,362,362,362,330,362,362,43,362,362
,362,362,43,362,362,330,194,362,362,362,362,362,362,362,330,43,362,162,43
,43,362,362,362,362,43,43,162,162,194,162,362,162,162,194,43,362,194,362
,362,362,362,194,162,162,162,162,194,43,162,362,162,43,162,162,362,362,194
,43,194,362,362,362,362,362,362,362,162,320,362,362,362,362,362,362,162
,162,362,362,194,362,362,362,362,362,362,194,194,194,362,320,362,362,362
,362,320,362,194,320,58,362,194,194,320,362,194,194,194,320,362,362,362
,362,362,362,162,362,362,320,194,320,58,362,362,325,362,58,362,362,58,194
,162,362,362,362,362,58,362,162,194,320,362,362,162,362,362,325,320,320
,320,362,325,362,362,325,362,362,362,320,325,362,362,320,320,325,362,320
,320,320,362,362,58,362,362,325,362,325,362,362,362,320,362,362,362,362
,358,362,362,362,58,362,320,362,58,362,362,325,362,58,58,320,362,362,325
,325,325,362,358,362,362,362,362,358,362,325,358,362,362,325,325,358,362
,325,325,325,358,362,362,362,362,362,58,362,362,362,358,325,358,362,362
,362,115,115,362,362,115,362,325,362,115,362,362,362,362,115,362,325,358
,362,362,362,362,362,115,358,358,358,362,115,362,362,115,362,362,362,358
,362,362,362,358,358,362,362,358,358,358,362,362,362,362,362,362,25,25,362
,115,25,358,362,362,25,362,362,54,54,25,362,54,358,362,362,54,362,115,25
,362,54,358,115,25,362,362,25,362,362,54,362,362,362,362,54,115,362,54,115
,115,362,362,362,362,115,115,362,362,362,362,25,362,362,362,115,362,362
,362,55,55,362,54,55,362,362,362,55,115,25,362,362,55,362,25,362,362,362
,115,362,54,55,362,362,362,54,55,25,362,55,25,25,362,362,362,362,25,25,54
,362,362,54,54,362,362,362,25,54,54,362,362,362,362,55,362,362,362,54,362
,25,45,45,362,362,45,362,362,362,45,25,54,55,362,45,362,362,55,362,362,362
,54,362,45,362,362,362,362,45,362,55,45,362,55,55,362,362,362,362,55,55
,362,362,362,161,161,362,362,161,55,362,362,161,362,362,45,362,161,362,362
,362,362,55,362,362,362,161,362,362,362,362,161,55,45,161,67,67,362,45,67
,362,362,362,67,362,362,362,362,67,362,362,45,362,362,45,45,362,67,161,362
,45,45,67,362,362,67,362,362,362,362,45,362,362,362,362,362,161,362,86,86
,362,161,86,45,362,362,86,362,362,67,362,86,362,45,161,362,362,161,161,362
,86,362,362,161,161,86,362,67,86,362,362,362,67,161,362,362,362,362,362
,362,362,362,362,362,362,67,161,362,67,67,362,362,86,362,67,67,161,362,362
,89,89,362,362,89,67,362,362,89,362,362,86,362,89,362,362,86,362,67,362
,362,362,89,362,362,362,362,89,67,86,89,362,86,86,362,362,362,362,86,86
,362,362,362,92,92,362,362,92,86,362,362,92,362,362,89,362,92,362,362,362
,362,86,362,362,362,92,362,362,362,362,92,86,89,92,96,96,362,89,96,362,362
,362,96,362,362,362,362,96,362,362,89,362,362,89,89,362,96,92,362,89,89
,96,362,362,96,362,362,362,362,89,362,362,362,362,362,92,362,47,47,362,92
,47,89,362,362,47,362,362,96,362,47,362,89,92,362,362,92,92,362,47,362,362
,92,92,47,362,96,47,362,362,362,96,92,362,362,362,362,362,362,362,362,362
,362,362,96,92,362,96,96,362,362,47,362,96,96,92,362,362,172,172,362,362
,172,96,362,362,172,362,362,47,362,172,362,362,47,362,96,362,362,362,172
,362,362,362,362,172,96,47,172,174,47,47,362,362,362,362,47,47,174,174,362
,362,362,174,174,362,47,362,362,362,362,362,172,362,174,174,174,174,362
,47,174,362,362,239,239,362,362,362,239,47,172,362,362,362,362,172,239,362
,362,362,362,362,362,174,362,239,174,174,172,362,239,172,172,239,362,362
,362,172,172,362,362,362,362,362,362,362,362,172,362,362,362,28,28,362,362
,362,28,239,362,362,172,362,362,362,28,138,174,362,362,362,172,362,362,28
,362,239,362,362,28,362,239,28,174,362,362,31,31,138,362,174,362,362,138
,239,174,138,362,239,31,108,362,362,239,239,362,28,362,31,362,362,362,362
,31,362,362,31,362,362,362,362,362,108,362,28,362,239,108,362,28,108,362
,362,362,362,362,239,110,138,362,31,362,28,138,362,362,28,362,56,362,362
,28,28,362,362,362,138,362,31,110,138,362,362,31,110,138,138,110,362,362
,56,362,108,362,28,56,31,108,56,362,31,362,362,12,28,31,31,362,138,362,108
,362,362,362,108,362,362,362,138,108,108,362,362,362,362,12,362,362,31,110
,12,362,362,12,110,362,362,362,31,94,56,362,108,362,362,56,362,110,362,362
,362,110,108,362,8,362,110,110,56,362,362,94,56,362,362,98,94,56,56,94,362
,362,362,362,362,12,8,362,362,110,12,8,362,362,8,100,362,98,362,110,56,362
,98,12,362,98,362,12,362,362,56,362,12,12,362,362,362,100,362,362,362,94
,100,362,362,100,94,362,362,128,362,362,362,362,362,12,8,362,362,94,362
,8,362,94,362,12,362,98,94,94,362,128,98,362,8,362,128,362,8,128,106,362
,362,8,8,98,362,100,362,98,362,94,100,362,98,98,362,362,362,362,362,94,106
,362,362,100,8,106,362,100,106,135,362,362,100,100,8,98,362,362,362,128
,362,362,362,362,128,98,296,362,362,296,362,135,362,362,362,100,135,128
,362,135,362,128,362,327,362,100,128,128,296,362,106,327,362,296,362,106
,296,362,362,362,116,362,333,362,362,327,362,362,106,128,327,362,106,327
,266,362,362,106,106,128,362,135,116,362,333,362,135,116,362,333,116,354
,333,362,354,362,266,116,296,135,106,266,362,135,266,362,362,362,135,135
,106,266,362,354,362,327,296,60,354,362,296,354,362,362,362,296,296,362
,362,362,362,135,116,327,333,362,362,327,362,60,362,135,327,327,60,362,266
,60,362,362,116,362,333,362,116,362,333,10,296,116,116,333,333,354,266,362
,362,362,266,362,362,319,362,266,266,327,362,362,142,10,362,354,362,362
,10,354,362,10,362,60,354,354,116,319,333,362,333,322,319,362,142,319,362
,362,362,142,266,60,142,362,362,60,324,362,253,362,60,60,362,322,362,362
,362,354,322,362,362,322,362,10,362,362,362,69,324,362,253,362,362,324,362
,253,324,319,253,362,362,10,362,60,142,10,362,255,362,69,10,10,362,362,69
,319,362,69,362,319,362,362,142,322,319,319,142,362,362,255,362,142,142
,362,255,362,362,255,324,362,253,322,362,10,362,322,362,362,329,362,322
,322,362,362,362,362,324,319,253,69,324,362,253,193,142,324,324,253,253
,362,329,362,362,362,362,329,362,69,329,255,362,69,331,322,362,193,69,69
,362,362,193,362,362,193,257,362,362,255,324,362,253,255,362,362,331,362
,255,255,362,331,362,362,331,362,362,362,257,362,362,69,329,257,362,362
,257,362,362,362,284,362,362,362,362,362,362,193,362,362,329,255,362,362
,329,286,362,362,362,329,329,362,284,362,362,193,331,284,362,193,284,362
,362,362,193,193,362,286,257,362,362,337,286,362,331,286,362,362,331,362
,362,362,329,331,331,71,257,362,362,362,257,362,103,337,362,257,257,193
,337,362,362,337,284,362,362,362,362,71,362,362,362,300,71,362,103,71,331
,286,362,103,284,362,103,362,284,362,343,362,257,284,284,362,362,300,362
,286,362,362,300,286,362,300,362,337,286,286,302,362,343,362,362,362,362
,343,362,362,343,71,362,362,362,337,284,362,103,337,304,362,302,362,337
,337,362,302,362,71,302,286,362,71,362,362,103,300,71,71,103,362,304,362
,362,103,103,304,362,362,304,362,343,362,73,300,362,337,362,300,362,306
,362,362,300,300,362,362,362,362,343,71,302,362,343,362,73,362,103,343,343
,73,362,306,73,362,362,362,306,362,302,306,304,362,302,241,362,300,362,302
,302,362,362,362,362,362,362,243,362,198,304,362,343,362,304,362,362,241
,362,304,304,362,241,362,362,241,73,362,362,243,362,198,302,306,243,362
,198,243,362,198,362,362,362,42,73,362,362,362,73,362,52,306,304,73,73,306
,362,362,362,362,306,306,362,362,362,42,362,241,362,362,42,362,52,42,362
,362,362,52,362,243,52,198,362,362,362,241,73,362,362,241,356,362,362,306
,241,241,362,243,362,198,362,243,357,198,270,362,243,243,198,198,362,362
,356,362,362,42,362,356,362,362,356,362,52,362,357,40,270,241,362,357,362
,270,357,42,270,362,362,42,362,243,52,198,42,42,52,362,362,40,362,52,52
,362,40,362,362,40,362,362,362,362,362,362,356,362,362,362,362,362,362,362
,362,362,362,362,357,42,270,362,362,362,356,362,52,362,356,362,362,362,362
,356,356,362,357,362,270,362,357,40,270,362,362,357,357,270,270,362,362
,362,362,362,362,362,362,362,362,40,362,362,362,40,362,362,356,362,40,40
,362,362,362,362,362,362,362,362,357,362,270,362,362,362,362,362,362,362
,362,362,362,362,362,362,362,362,362,362,362,362,362,40,362,362,362,362
,362,362,362,362,362}
,
{1102,0,1507,1642,987,120,6509,6189,12860,329,13135,0,12809,142,72,9929
,10052,20,10922,5190,10168,2775,1857,11096,1507,12086,284,640,12678,519
,287,12712,90,188,10226,377,5077,2276,1372,1102,13693,5957,13611,11720,379
,12209,532,12504,1296,1237,1432,1196,13618,373,12097,12148,12774,710,11893
,405,13095,11038,1642,11382,914,9994,1777,12283,486,13211,534,13407,569
,13522,576,590,596,614,635,637,225,649,601,653,0,8,12326,729,328,12387,790
,449,12430,491,12845,191,12461,496,12871,378,12891,443,499,13414,32,615
,12956,502,12726,1,12763,1731,582,10110,316,12035,13038,321,8537,9176,299
,373,10342,162,494,10400,507,427,12925,218,568,10516,174,79,574,12987,76
,595,12692,414,10806,484,13156,2849,619,7789,6349,192,427,570,11440,93,7309
,5885,252,297,328,365,6749,6429,413,12252,11806,4850,76,501,7469,4606,473
,7949,4489,5678,12565,10574,12590,10632,210,10690,570,203,10748,225,7069
,5725,10980,280,7389,5805,251,11154,68,11270,351,13287,11801,244,7549,4961
,13577,9362,9761,9581,353,11471,5060,9049,12,340,6078,8213,8369,8756,9214
,2397,8990,5401,7149,2641,4116,4850,2020,8322,11212,400,7629,1898,846,8731
,8109,2896,6909,2519,8802,5401,1,7229,968,8188,23,12630,132,13563,218,13575
,261,2142,8597,3018,195,4238,4360,3506,3628,13192,5624,13231,8455,13318
,6669,3750,6829,3872,6989,3994,325,338,13052,5523,571,574,13672,49,9,528
,9448,5965,3140,10284,6078,3262,546,10458,6269,3384,13352,45,13367,1043
,658,340,4,33,11526,947,12,48,13004,113,310,392,13433,1136,13468,760,13488
,8857,13529,8904,9847,9495,372,11611,5189,10864,83,7709,5288,423,9202,13149
,11862,238,13175,525,13190,11918,532,13021,5569,13272,11677,13306,536,13040
,523,7869,4717,13393,578,9127,11328,577,9918,13448,9315,9628,9714,579,11326
,11555,9116,8029,6589,568,13069,650,13658,13670,11979,8667,668,673}
,
{
{{37,37}
,{1,1}
,{37,37}
,{83,83}
,{22,22}
,{5,5}
,{1,1}
,{1,1}
,{2,2}
,{5,5}
,{2,2}
,{2,4}
,{2,2}
,{2,4}
,{96,96}
,{2,2}
,{56,56}
,{5,5}
,{56,56}
,{5,5}
,{56,56}
,{5,5}
,{22,22}
,{56,56}
,{5,5}
,{56,56}
,{2,4}
,{3,3}
,{7,7}
,{7,7}
,{7,4}
,{2,2}
,{4,4}
,{3,3}
,{56,56}
,{11,11}
,{5,5}
,{5,5}
,{5,5}
,{5,5}
,{2,2}
,{2,2}
,{2,2}
,{23,23}
,{23,23}
,{56,56}
,{19,19}
,{56,56}
,{22,22}
,{5,4}
,{22,22}
,{22,22}
,{2,2}
,{65,65}
,{56,56}
,{56,56}
,{2,2}
,{4,4}
,{2,2}
,{32,32}
,{2,2}
,{56,56}
,{5,5}
,{56,56}
,{40,40}
,{56,56}
,{5,5}
,{56,56}
,{5,5}
,{2,2}
,{5,5}
,{2,2}
,{5,5}
,{2,2}
,{5,5}
,{5,5}
,{5,5}
,{5,5}
,{5,5}
,{5,5}
,{5,5}
,{5,5}
,{56,56}
,{5,5}
,{3,3}
,{5,5}
,{56,56}
,{5,5}
,{5,5}
,{56,56}
,{22,22}
,{5,5}
,{56,56}
,{23,23}
,{2,2}
,{5,5}
,{56,56}
,{70,70}
,{2,2}
,{5,5}
,{2,2}
,{5,5}
,{98,98}
,{2,2}
,{5,5}
,{5,5}
,{2,2}
,{5,5}
,{2,2}
,{5,5}
,{2,2}
,{87,87}
,{87,87}
,{56,56}
,{5,5}
,{56,56}
,{2,2}
,{5,5}
,{2,2}
,{70,70}
,{70,70}
,{70,70}
,{56,56}
,{5,5}
,{5,5}
,{56,56}
,{5,5}
,{70,70}
,{2,2}
,{5,5}
,{5,5}
,{56,56}
,{5,5}
,{32,32}
,{9,9}
,{2,2}
,{5,5}
,{5,5}
,{2,2}
,{19,19}
,{56,56}
,{5,5}
,{2,2}
,{30,30}
,{30,30}
,{56,56}
,{38,38}
,{47,47}
,{1,1}
,{1,1}
,{56,56}
,{62,62}
,{56,56}
,{38,38}
,{38,38}
,{38,38}
,{28,28}
,{5,5}
,{56,56}
,{38,38}
,{29,29}
,{56,56}
,{57,57}
,{38,38}
,{108,108}
,{5,5}
,{56,56}
,{8,8}
,{62,62}
,{56,56}
,{8,8}
,{22,22}
,{56,56}
,{56,56}
,{62,62}
,{56,56}
,{40,40}
,{56,56}
,{62,62}
,{38,38}
,{56,56}
,{62,62}
,{56,56}
,{38,38}
,{56,56}
,{62,62}
,{56,56}
,{38,38}
,{30,4}
,{56,56}
,{40,40}
,{56,56}
,{30,30}
,{2,2}
,{37,37}
,{9,9}
,{56,56}
,{2,2}
,{2,2}
,{20,20}
,{20,20}
,{38,38}
,{81,81}
,{5,5}
,{37,37}
,{20,20}
,{136,136}
,{136,136}
,{20,20}
,{20,20}
,{20,20}
,{20,20}
,{20,20}
,{20,20}
,{20,20}
,{28,28}
,{56,56}
,{20,20}
,{20,20}
,{56,56}
,{20,20}
,{20,20}
,{56,56}
,{57,57}
,{56,56}
,{20,20}
,{28,28}
,{5,5}
,{56,56}
,{20,20}
,{56,56}
,{20,20}
,{2,2}
,{20,20}
,{57,57}
,{56,56}
,{2,2}
,{5,5}
,{3,3}
,{7,7}
,{7,7}
,{2,2}
,{3,3}
,{2,2}
,{5,5}
,{20,20}
,{20,20}
,{20,20}
,{115,115}
,{20,20}
,{20,20}
,{20,20}
,{20,20}
,{2,2}
,{20,20}
,{2,2}
,{20,4}
,{2,2}
,{56,56}
,{20,20}
,{56,56}
,{20,20}
,{56,56}
,{20,20}
,{115,115}
,{115,115}
,{2,2}
,{20,20}
,{5,5}
,{5,5}
,{2,2}
,{63,63}
,{63,63}
,{63,63}
,{20,20}
,{56,56}
,{20,20}
,{56,56}
,{56,56}
,{20,20}
,{88,88}
,{56,56}
,{56,56}
,{20,20}
,{2,2}
,{19,4}
,{2,2}
,{5,5}
,{5,5}
,{38,38}
,{38,38}
,{53,53}
,{5,5}
,{38,38}
,{38,38}
,{52,52}
,{5,5}
,{5,5}
,{38,38}
,{38,38}
,{2,2}
,{38,38}
,{2,2}
,{38,4}
,{2,2}
,{20,20}
,{2,2}
,{20,20}
,{20,20}
,{38,38}
,{37,37}
,{5,5}
,{37,37}
,{56,56}
,{21,21}
,{56,56}
,{37,37}
,{54,54}
,{37,37}
,{2,2}
,{37,37}
,{8,4}
,{2,2}
,{5,5}
,{2,2}
,{37,37}
,{8,8}
,{2,2}
,{5,5}
,{2,2}
,{2,2}
,{2,2}
,{41,41}
,{2,2}
,{57,57}
,{56,56}
,{2,2}
,{2,2}
,{11,11}
,{2,2}
,{2,2}
,{19,19}
,{2,2}
,{2,2}
,{20,20}
,{20,20}
,{38,38}
,{42,42}
,{2,2}
,{5,5}
,{37,37}
,{56,56}
,{38,38}
,{82,82}
,{5,5}
,{5,5}
,{2,2}
,{2,2}
,{37,37}
,{5,5}
,{5,5}
,{5,5}
}
,
{8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
,
{0,0,0,0,6,0,15,0,0,0,120,0,96,0,0,4,1,17}
,
{52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
}
};


/* Non terminal table *\
\* ------------------ */
typedef  struct {
    UByte2 gto[2095];		/* Goto table */
    UByte2 gtoRix[362];		/* Goto row mapping */
    UByte2 lhs[368];		/* Left hand side symbols */
    UByte1 rhsz[368];		/* Size of the RHS */
} NonTermTab;

static NonTermTab gto = {
{97,2137,841,962,418,217,2826,882,954,2826,162,138,297,2617,1905,226,618
,1649,2177,2881,10,122,178,946,473,305,2354,1569,1385,154,890,906,1274,321
,2057,2826,1442,2577,1873,1905,58,674,1073,146,114,170,130,1081,842,2338
,1993,1657,137,1145,97,97,354,1513,914,265,217,1090,1554,2289,1905,850,393
,297,2802,1769,1777,1793,1617,666,898,2185,1905,313,481,2617,305,209,1282
,2353,1082,866,98,2522,321,209,2353,97,2578,1914,2609,378,217,97,2569,2817
,225,2137,265,962,49,402,2145,882,954,2633,1689,473,1594,1602,473,1913,1401
,1649,417,2665,1570,393,266,946,321,1881,1025,1578,433,2522,890,906,313
,481,249,849,2378,433,2530,2378,1922,2522,2522,858,314,1610,1618,1626,842
,1586,1993,1657,1018,2594,273,225,1314,393,914,922,2137,386,962,1145,1665
,266,882,954,313,481,1929,1161,1562,1569,898,1881,1649,249,2522,1145,1097
,2161,946,2353,2522,866,1441,473,1554,890,906,225,2530,2530,969,1985,2010
,273,762,2018,418,698,346,1914,1313,1377,1314,842,1377,1993,1657,97,2338
,241,650,433,265,914,2153,1914,401,1073,1594,1602,1353,1145,1081,1353,433
,2530,1570,1249,1977,898,1554,2530,1145,1578,1594,1602,905,65,2353,858,866
,1554,1570,2810,466,2041,1922,1241,1753,1578,2321,1610,1618,1626,2826,1586
,2266,2354,193,1561,433,1914,1922,650,737,2826,2649,1610,1618,1626,1145
,1586,1914,2361,2313,274,2802,417,1090,1554,1594,1602,2577,433,97,1721,1369
,1145,1570,817,2865,1594,1602,2433,2522,1578,1554,410,858,1570,2329,1082
,2802,1473,2522,1530,1578,273,1922,17,1914,97,2665,1610,1618,1626,865,1586
,473,1922,2393,2594,802,2393,1610,1618,1626,1914,1586,1594,1602,570,1145
,1090,538,554,802,1570,2881,2802,2401,1554,1145,2346,1578,2530,1594,1602
,1505,394,1697,1554,1058,578,1570,1121,1082,1922,1585,50,2385,1578,1610
,1618,1626,2873,1586,433,433,650,25,2522,1914,2802,1922,433,930,802,1186
,1610,1618,1626,1914,1586,1681,97,2505,1145,1705,322,217,1594,1602,1434
,650,1226,1554,2818,2522,1570,2473,1594,1602,1177,1145,97,1578,2370,713
,1570,881,2193,417,1554,1609,490,1578,185,377,1922,1745,945,2530,1641,1610
,1618,1626,1914,1586,1922,2802,874,433,1737,1610,1618,1626,2322,1586,345
,97,474,1145,2201,1914,217,1594,1602,209,2530,1329,1554,297,345,1570,2769
,626,2809,1233,1066,2305,1578,97,1594,1602,305,33,217,569,345,961,1570,2522
,321,1922,585,522,657,1578,1610,1618,1626,1914,1586,1370,225,977,562,2417
,97,601,1922,2522,1001,217,2386,1610,1618,1626,1145,1586,1594,1602,2449
,810,2465,393,97,1554,1570,1145,1793,897,361,2849,1809,1578,313,481,1554
,185,2481,2458,2530,657,209,1841,2522,1154,1922,770,1889,2529,185,1610,1618
,1626,2681,1586,1914,225,209,1506,2530,1049,209,2593,210,1145,2522,1914
,97,1961,2362,1105,337,113,1554,1594,1602,2314,1153,225,209,1857,1145,1570
,209,2713,1594,1602,2729,442,1578,1554,2753,2522,1570,2530,2761,209,1897
,2777,2514,1578,97,1922,2801,1914,225,217,1610,1618,1626,2522,1586,2482
,1922,722,1193,2530,1162,1610,1618,1626,1914,1586,1594,1602,2834,1145,1394
,97,2042,1601,1570,2889,81,321,1554,1145,0,1578,0,1594,1602,2009,2530,97
,1554,0,0,1570,769,0,1922,2025,0,2522,1578,1610,1618,1626,97,1586,2530,0
,0,217,0,1914,393,1922,0,0,0,0,1610,1618,1626,1914,1586,1545,481,0,1145
,0,0,97,1594,1602,0,2522,217,1554,0,553,1570,0,1594,1602,2081,1145,97,1578
,225,0,1570,465,2530,0,1554,0,177,1578,97,0,1922,2097,2522,217,321,1610
,1618,1626,1914,1586,1922,0,0,0,0,1610,1618,1626,2522,1586,0,0,0,1145,0
,1914,2530,1594,1602,0,0,705,1554,2522,1145,1570,0,393,0,2113,0,0,1578,1554
,1594,1602,225,0,313,481,2217,0,1570,2530,0,1922,0,0,2522,1578,1610,1618
,1626,1914,1586,0,0,0,0,2530,0,225,1922,2522,1914,0,0,1610,1618,1626,1145
,1586,1594,1602,2530,2522,0,0,0,1554,1570,1145,0,1594,1602,0,2241,1578,225
,0,1554,1570,0,0,0,0,0,2273,1578,2530,1922,0,0,0,0,1610,1618,1626,0,1586
,1914,1922,0,0,2530,0,1610,1618,1626,1145,1586,1914,0,0,0,0,2530,0,1554
,1594,1602,0,0,0,0,1281,1145,1570,0,0,1594,1602,0,0,1578,1554,0,0,1570,97
,0,0,2537,0,217,1578,0,1922,0,1914,1145,0,1610,1618,1626,0,1586,0,1922,1562
,0,0,0,1610,1618,1626,1914,1586,1594,1602,0,1145,729,0,97,0,1570,0,0,217
,1554,0,0,1578,0,1594,1602,2697,1145,0,1914,0,0,1570,0,0,1922,1554,0,0,1578
,1610,1618,1626,1345,1586,0,753,0,1594,1602,1914,1145,1922,0,0,0,1570,1610
,1618,1626,1562,1586,1474,1578,0,2522,0,1914,0,1594,1602,0,0,1386,0,1073
,1922,1570,225,0,1081,1610,1618,1626,1578,1586,1594,1602,97,1145,0,1914
,0,801,1570,0,0,1922,1554,1145,2522,1578,1610,1618,1626,2825,1586,0,1562
,0,1594,1602,0,225,1922,0,2530,0,1570,1610,1618,1626,97,1586,0,1578,0,217
,97,1914,0,0,0,217,0,0,0,1145,1922,1914,297,0,0,1610,1618,1626,1562,1586
,1594,1602,0,2530,0,305,0,785,1570,0,1594,1602,1145,321,2522,1578,0,0,1570
,0,0,1562,0,0,0,1578,0,2522,1922,1914,0,0,0,1610,1618,1626,0,1586,1922,0
,0,0,0,1610,1618,1626,393,1586,1594,1602,1145,993,1914,0,0,0,1570,313,481
,1562,1145,2522,0,1578,0,1041,0,2522,0,1562,0,1594,1602,0,225,0,1922,0,2530
,1570,225,1610,1618,1626,0,1586,1578,0,0,97,1914,0,0,0,217,0,0,0,1145,1922
,1914,297,0,0,1610,1618,1626,1562,1586,1594,1602,0,2530,0,305,0,0,1570,2530
,1594,1602,1145,321,0,1578,0,0,1570,0,0,1562,0,0,0,1578,0,0,1922,1914,0
,0,0,1610,1618,1626,0,1586,1922,0,0,0,0,1610,1618,1626,393,1586,1594,1602
,1145,1017,1914,0,0,0,1570,313,481,1562,1145,0,0,1578,0,0,0,2522,0,1562
,0,1594,1602,0,0,0,1922,0,0,1570,225,1610,1618,1626,0,1586,1578,0,0,97,1914
,0,0,0,217,0,0,97,1145,1922,1914,297,217,0,1610,1618,1626,1562,1586,1594
,1602,0,0,0,305,0,97,1570,2530,1594,1602,217,321,0,1578,0,0,1570,0,0,321
,0,0,0,1578,0,97,1922,1914,0,0,217,1610,1618,1626,97,1586,1922,297,2466
,217,0,1610,1618,1626,393,1586,1594,1602,1145,1457,305,0,393,0,1570,313
,481,1562,321,1145,0,1578,0,521,481,2522,0,937,1562,0,0,0,0,2522,1922,0
,0,0,225,1610,1618,1626,0,1586,0,0,225,0,1914,0,0,393,2522,0,0,0,1065,1145
,0,1914,0,0,313,481,0,225,1562,1594,1602,0,0,0,2522,0,0,1570,2530,0,1594
,1602,1145,2522,1578,0,2530,225,1570,0,0,1562,0,0,0,1578,225,1922,1145,1914
,0,0,1610,1618,1626,2530,1586,1562,1922,0,0,97,0,1610,1618,1626,217,1586
,1594,1602,0,0,1914,297,0,2530,1570,0,0,0,0,0,0,1578,2530,97,305,0,1914
,0,217,1594,1602,0,321,0,1922,297,0,1570,0,1610,1618,1626,0,1586,1578,1594
,1602,0,305,0,0,0,1145,1570,0,0,321,1922,0,0,1578,1562,1610,1618,1626,393
,1586,0,0,0,1489,0,0,1922,0,1145,313,481,1610,1618,1626,0,1586,0,1562,0
,2522,0,0,393,0,0,1914,0,1137,0,1145,0,0,225,313,481,0,0,0,1562,0,0,97,0
,2522,1594,1602,217,0,1914,0,0,0,1570,297,0,0,225,0,0,1578,97,0,0,0,0,217
,305,1594,1602,1914,2530,0,1922,0,321,1570,0,1610,1618,1626,97,1586,1578
,0,0,217,0,0,1594,1602,0,0,297,1305,2530,1922,1570,0,0,0,1610,1618,1626
,1578,1586,305,0,393,0,0,0,0,2233,321,0,97,1922,0,313,481,217,1610,1618
,1626,0,1586,0,297,2522,1145,97,0,0,0,0,217,0,0,1562,0,305,225,0,0,0,1145
,393,2522,321,0,0,145,0,0,1562,0,0,313,481,0,225,0,0,2618,0,0,0,2522,1145
,1914,0,0,0,0,0,0,0,1562,0,2530,225,393,0,0,0,1914,2265,0,1594,1602,0,0
,313,481,0,0,1570,0,2530,0,0,97,2522,1578,1594,1602,217,0,1914,0,0,0,1570
,297,0,225,1922,2522,2530,1578,0,1610,1618,1626,0,1586,305,1594,1602,0,225
,0,1922,0,321,1570,0,1610,1618,1626,97,1586,1578,97,97,217,0,0,217,217,0
,0,297,2530,0,1922,297,0,0,0,1610,1618,1626,0,1586,305,0,393,2530,305,0
,0,2521,321,1145,0,2626,321,313,481,0,0,0,1562,0,0,0,0,2522,0,0,0,0,0,0
,0,0,0,1145,0,0,225,0,0,0,0,393,1562,0,0,393,1217,0,0,1914,289,0,313,481
,0,0,313,481,0,0,0,0,2522,0,0,2522,2522,0,1594,1602,0,1145,0,1914,2530,225
,1570,0,225,225,1562,0,0,1578,0,0,0,0,0,0,0,0,1594,1602,0,0,1922,0,0,0,1570
,1610,1618,1626,0,1586,0,1578,0,97,1145,1914,0,2530,217,0,2530,2530,0,1562
,1922,297,0,97,0,1610,1618,1626,217,1586,1594,1602,0,0,305,161,0,0,1570
,97,0,97,321,0,217,1578,217,0,305,97,1914,0,0,0,217,97,321,0,1922,0,217
,0,0,1610,1618,1626,0,1586,0,1594,1602,0,321,0,321,393,0,1570,0,0,921,0
,2330,0,1578,0,313,481,321,393,0,0,0,0,97,0,2522,1922,0,217,313,481,1610
,1618,1626,393,1586,393,0,225,2522,0,0,0,0,0,537,481,201,481,97,393,0,225
,97,217,2522,321,2522,217,0,0,505,481,0,0,2522,0,0,225,0,225,2522,0,0,0
,0,2530,0,225,0,0,0,321,0,225,0,321,0,0,393,2530,0,0,0,0,0,0,0,0,0,1417
,481,0,0,0,0,2530,0,2530,0,2522,0,0,0,0,393,2530,0,0,393,0,0,2530,225,0
,0,1433,481,0,0,1529,481,0,0,0,0,2522,0,0,0,2522,0,0,0,0,0,0,0,0,225,0,0
,0,225,0,0,0,0,0,0,0,2530,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
,0,0,2530,0,0,0,2530}
,
{259,18,382,7,87,14,172,928,616,13,92,13,555,13,13,0,1547,13,1855,13,672
,326,243,1873,551,1881,13,13,97,13,13,211,13,13,1711,13,13,442,529,558,564
,378,587,389,12,493,12,1255,186,12,321,244,557,12,1597,1710,687,12,348,12
,600,1887,61,1236,69,1871,432,647,12,472,12,479,12,494,12,11,10,10,9,9,407
,9,9,9,9,9,699,308,7,860,251,6,895,6,632,6,1004,6,970,6,288,6,6,2,1,5,315
,5,409,4,511,136,4,1841,4,1284,362,4,324,55,338,4,1010,398,3,1119,3,3,957
,416,3,1275,3,3,3,42,426,3,221,3,1423,2,565,23,2,338,1582,550,552,2,1707
,2,393,110,98,2,2,2,777,966,2,1527,110,113,390,2,856,1037,2,221,1136,9,466
,91,429,1926,509,1952,525,1,1228,1,238,1256,1399,1,283,1399,1,1956,547,589
,564,173,27,1,293,1543,618,294,0,0,1,343,1,16,39,1,280,1,244,289,280,183
,392,340,355,1688,1750,0,1789,1,444,1,450,989,1,360,461,1027,499,1075,14
,64,444,516,1098,15,1,54,1,551,1,556,1,126,367,1146,328,561,1184,571,1245
,247,401,6,474,613,616,1294,633,1317,671,1333,52,273,39,76,0,0,18,16,271
,387,26,682,1422,1508,728,1443,0,1582,739,1559,35,0,464,148,0,208,0,0,68
,221,423,0,280,0,261,373,492,218,269,0,507,461,509,280,453,100,0,306,489
,1668,525,794,818,0,485,9,258,0,550,0,13,79,0,4,200,119,0,316,0,419,0,839
,1712,572,0,439,521,0,538,583,335,514,159,0,548,377,558,918,880,0,434,0
,615,342,19,620,0,0}
,
{198,259,259,179,179,171,171,165,165,165,232,232,223,223,223,223,223,223
,223,223,223,223,211,211,286,286,286,286,286,286,260,260,224,224,212,212
,212,180,233,233,279,181,234,234,173,166,225,225,226,249,249,245,245,280
,280,199,199,295,295,273,266,266,297,297,147,227,200,200,267,267,262,261
,201,250,250,250,214,214,160,240,240,150,158,217,184,184,182,185,185,186
,187,187,188,188,183,242,189,189,268,268,190,191,191,216,216,192,192,192
,192,192,192,192,192,192,192,192,192,192,192,192,193,193,194,194,152,274
,274,145,145,145,288,288,229,229,251,251,176,176,153,153,175,218,202,151
,174,275,275,287,195,195,269,269,246,246,252,252,253,253,168,168,162,235
,235,255,255,254,254,247,247,263,263,263,159,236,219,167,203,203,204,204
,154,154,154,148,155,155,270,270,205,205,157,281,281,213,213,206,206,206
,206,206,206,206,206,264,264,264,264,264,264,264,196,196,196,196,196,293
,293,293,293,257,257,289,289,289,289,289,276,276,294,294,294,296,296,296
,296,296,243,243,291,291,237,285,285,220,220,277,277,284,208,208,238,238
,230,230,290,209,209,292,292,292,197,197,197,256,256,278,278,271,271,271
,271,271,271,271,271,283,283,215,215,156,156,169,169,169,169,169,221,221
,221,221,221,178,178,170,170,170,258,258,258,258,177,177,177,177,177,177
,177,177,210,210,222,222,222,207,149,149,231,231,231,231,282,282,248,248
,161,161,161,161,161,164,164,164,164,163,163,163,163,163,163,163,241,241
,241,241,239,239,272,272,228,228,146,146,172,172,265,265,244,244,144,144
,144,144,144,144,144,144,144,144}
,
{3,0,2,1,1,1,2,2,3,3,0,2,1,1,1,1,1,1,1,1,1,1,2,3,1,2,2,2,3,4,0,1,1,3,1,1
,2,2,1,2,4,2,1,2,3,2,1,2,4,1,2,1,4,0,2,1,1,1,3,5,1,1,1,2,3,2,1,1,1,2,3,2
,4,0,2,2,1,3,3,0,1,3,5,4,0,1,7,0,1,5,0,1,0,1,5,4,0,1,0,1,3,0,1,0,2,2,1,1
,2,1,1,1,1,1,2,2,2,1,1,1,0,1,0,1,6,0,5,1,1,1,0,1,3,2,1,1,1,2,1,2,2,2,2,3
,3,0,1,4,0,1,0,1,5,1,0,3,0,2,1,2,3,1,1,1,2,0,2,0,2,0,3,2,3,2,4,5,0,1,1,2
,2,4,5,5,1,1,0,3,0,1,4,0,1,1,2,1,1,1,1,1,1,1,1,1,3,4,3,3,3,3,0,1,1,1,1,4
,4,5,5,3,6,4,8,4,4,5,0,2,0,1,1,0,1,1,1,1,0,2,1,1,9,0,1,4,5,0,2,7,1,1,1,2
,2,3,8,0,1,0,1,4,1,1,2,3,5,0,2,2,2,2,2,2,3,3,3,0,1,1,3,1,3,1,3,4,4,6,1,2
,3,3,3,1,3,2,3,2,1,3,3,5,1,1,1,2,3,3,4,4,1,3,1,1,1,2,1,1,1,1,2,2,3,3,0,1
,2,2,3,3,3,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,1,0,1,0,1,1,2,1,3,0,1,0,1,1,1
,1,1,1,1,1,1,1,1}
};


/* Vocabulary *\
\* ---------- */
typedef struct {
    UByte1 scc;			/* Scanner code value */
    UByte1 iCost;		/* Insertion cost */
    UByte1 dCost;		/* Deletion cost */
    char *name;			/* Name string */
    char *psym;			/* Print name */
} VocTab[143];
			     
static VocTab voc = {{1,255,255,"EndOfText",""}
,{2,1,1,"Identifier","<identifier>"}
,{3,2,1,"Integer",""}
,{4,1,1,"','",""}
,{5,1,1,"'.'",""}
,{6,1,1,"'{'",""}
,{7,1,1,"'}'",""}
,{8,1,1,"'='",""}
,{9,1,1,"':'",""}
,{10,1,1,"'('",""}
,{11,1,1,"')'",""}
,{12,1,1,"'*'",""}
,{13,1,1,"'!'",""}
,{14,1,1,"'+'",""}
,{15,1,1,"'-'",""}
,{16,1,1,"'/'",""}
,{17,1,1,"'>'",""}
,{18,1,1,"'<'",""}
,{19,1,1,"'to'",""}
,{20,1,1,"'is'",""}
,{21,1,1,"'=>'",""}
,{22,1,1,"'at'",""}
,{23,1,1,"'in'",""}
,{24,1,1,"'it'",""}
,{25,1,1,"'an'",""}
,{26,1,1,"'no'",""}
,{27,1,1,"'by'",""}
,{28,1,1,"'if'",""}
,{29,1,1,"'on'",""}
,{30,1,1,"'do'",""}
,{31,1,1,"'or'",""}
,{32,1,1,"'of'",""}
,{33,1,1,"'<>'",""}
,{34,1,1,"'=='",""}
,{35,1,1,"'>='",""}
,{36,1,1,"'<='",""}
,{37,1,1,"'the'",""}
,{38,1,1,"'end'",""}
,{39,1,1,"'not'",""}
,{40,1,1,"'and'",""}
,{41,1,1,"'isa'",""}
,{42,1,1,"'add'",""}
,{43,1,1,"'are'",""}
,{44,1,1,"'has'",""}
,{45,1,1,"'say'",""}
,{46,1,1,"'set'",""}
,{47,1,1,"'for'",""}
,{48,1,1,"'use'",""}
,{49,1,1,"'max'",""}
,{50,1,1,"'min'",""}
,{51,1,1,"'sum'",""}
,{52,1,1,"'verb'",""}
,{53,1,1,"'exit'",""}
,{54,1,1,"'when'",""}
,{55,1,1,"'quit'",""}
,{56,1,1,"STRING",""}
,{57,1,1,"'else'",""}
,{58,1,1,"'does'",""}
,{59,1,1,"'form'",""}
,{60,1,1,"'name'",""}
,{61,1,1,"'with'",""}
,{62,1,1,"'then'",""}
,{63,1,1,"'step'",""}
,{64,1,1,"'wait'",""}
,{65,1,1,"'here'",""}
,{66,1,1,"'near'",""}
,{67,1,1,"'list'",""}
,{68,1,1,"'show'",""}
,{69,1,1,"'play'",""}
,{70,1,1,"'from'",""}
,{71,1,1,"'make'",""}
,{72,1,1,"'last'",""}
,{73,1,1,"'word'",""}
,{74,1,1,"'into'",""}
,{75,1,1,"'each'",""}
,{76,1,1,"'stop'",""}
,{77,1,1,"'look'",""}
,{78,1,1,"'save'",""}
,{79,1,1,"'this'",""}
,{80,1,1,"'only'",""}
,{81,1,1,"'every'",""}
,{82,1,1,"'event'",""}
,{83,1,1,"'start'",""}
,{84,1,1,"'check'",""}
,{85,1,1,"'where'",""}
,{86,1,1,"'count'",""}
,{87,1,1,"'after'",""}
,{88,1,1,"'until'",""}
,{89,1,1,"'style'",""}
,{90,1,1,"'empty'",""}
,{91,1,1,"'strip'",""}
,{92,1,1,"'first'",""}
,{93,1,1,"'words'",""}
,{94,1,1,"'elsif'",""}
,{95,1,1,"'score'",""}
,{96,1,1,"'actor'",""}
,{97,1,1,"'syntax'",""}
,{98,1,1,"'script'",""}
,{99,1,1,"'option'",""}
,{100,1,1,"'import'",""}
,{101,1,1,"'opaque'",""}
,{102,1,1,"'taking'",""}
,{103,1,1,"'limits'",""}
,{104,1,1,"'header'",""}
,{105,1,1,"'nearby'",""}
,{106,1,1,"'locate'",""}
,{107,1,1,"'cancel'",""}
,{108,1,1,"'depend'",""}
,{109,1,1,"'visits'",""}
,{110,1,1,"'system'",""}
,{111,1,1,"'random'",""}
,{112,1,1,"'before'",""}
,{113,1,1,"'options'",""}
,{114,1,1,"'message'",""}
,{115,1,1,"'article'",""}
,{116,1,1,"'entered'",""}
,{117,1,1,"'pronoun'",""}
,{118,1,1,"'extract'",""}
,{119,1,1,"'include'",""}
,{120,1,1,"'exclude'",""}
,{121,1,1,"'between'",""}
,{122,1,1,"'restore'",""}
,{123,1,1,"'restart'",""}
,{124,1,1,"'current'",""}
,{125,1,1,"'synonyms'",""}
,{126,1,1,"'definite'",""}
,{127,1,1,"'negative'",""}
,{128,1,1,"'directly'",""}
,{129,1,1,"'describe'",""}
,{130,1,1,"'schedule'",""}
,{131,1,1,"'increase'",""}
,{132,1,1,"'decrease'",""}
,{133,1,1,"'contains'",""}
,{134,1,1,"'location'",""}
,{135,1,1,"'mentioned'",""}
,{136,1,1,"'container'",""}
,{137,1,1,"'character'",""}
,{138,1,1,"'depending'",""}
,{139,1,1,"'attributes'",""}
,{140,1,1,"'indefinite'",""}
,{141,1,1,"'initialize'",""}
,{142,1,1,"'characters'",""}
,{143,1,1,"'description'",""}
}
;


/* Variables used in the parsing process *\
\* ------------------------------------- */
short pmStkP;			/* Stack pointer */
Token pmSySt[PmStkMax];	/* Symbol stack */
pmGrammar pmSeSt[PmStkMax];	/* Semantic stack */ 
static UByte2 currstat;		/* Current state number */
static UByte2 arg;		/* Argument */
static UByte1 action;		/* Action type */
static PmBoolean endparse;	/* Termination flag */
static ParseStack parsStk;	/* Parse stack */
static UByte1 scIndex[143 + 1]; /* Converts scanner code to internal value */
static Token tokenBuf;	/* Scanner token buffer */
static Token *token = &tokenBuf;	/* Pointer to it for readsymb */


/* Error recovery look-ahead buffer *\
\* -------------------------------- */
static Token la_buff[PmLaMax + 1]; /* Buffer */
static int la_ptr;		/* Current pointer */
static int la_end;		/* Last item */

static jmp_buf pmJmpB;		/* Buffer for long jump */

/* Interface routines *\
\* ------------------ */

extern void pmRPoi(	/* Error recovery - restart point  */
Token *sym			/* IN the restart symbol */
);
extern void pmISym(	/* Error recovery - insert symbol  */
int code,			/* IN terminal code number */
char *sstr,			/* IN terminal string */
char *pstr,			/* IN the terminals print symbol */
Token *sym			/* OUT the created scanner symbol */
);
extern void pmDSym(	/* Error recovery - delete symbol  */
Token *sym,			/* IN terminal code number */
char *sstr,			/* IN terminal string */
char *pstr			/* IN terminals print string */
);
extern void pmMess(	/* Error recovery - error message  */
Token *sym,			/* IN error token */
int method,			/* IN recovery method */
int code,			/* IN error classification */
int severity			/* IN error severity code */
);

/* External functions */
extern void pmPaSema(
int rule			/* IN production number */
);

/*----------------------------------------------------------------------------
 * paAbort - Abort the parsing process
 *----------------------------------------------------------------------------
 */
static void paAbort(
Token *token,		/* IN current token */
short eClass,			/* IN error classification */
short severity			/* IN error severity code */
)
{
    pmMess(token, HALT_REC, eClass, severity);
    longjmp(pmJmpB, PMTRUE);	/* Jump out to top level */
}/*paAbort()*/


/*----------------------------------------------------------------------------
 * SetIns - Add one element to a set
 *----------------------------------------------------------------------------
 */
#define SetIns(set, n) ((set)[(n) >> 3] |= (0x80 >> ((n) & 0x7)))


/*----------------------------------------------------------------------------
 * SetClear - Clear a ParserMaker set
 *----------------------------------------------------------------------------
 */
#define SetClear(set, length) memset((void *)set, 0, (size_t)((length) + 7) >> 3)

/*----------------------------------------------------------------------------
 * SetMem - Check member inclusion
 *----------------------------------------------------------------------------
 */
#define SetMem(set, n) ((set)[(n) >> 3] & (0x80 >> ((n) & 0x7)))


/*----------------------------------------------------------------------------
 * paInit - Initialize the parsing process
 *----------------------------------------------------------------------------
 */
static void paInit(void)
{
    short i;

    la_ptr = 0;
    la_end = 0;
    pmStkP = 0;
    currstat = 1;
    endparse = PMFALSE;
    parsStk[0] = 1;

    /* Scanner interface */
    for (i = 0; i <= SccMax; i++) scIndex[i] = ERR_SYM;
    for (i = TermMin; i <= Terms; i++) scIndex[voc[i - TermMin].scc] = (UByte1)i;
}/*paInit()*/


/*----------------------------------------------------------------------------
 * pushStat[Tok] - Push the current state on the stack and possibly push current
 *	      token on the symbol stack.
 *----------------------------------------------------------------------------
 */
#define MOVETOKEN pmSySt[pmStkP] = *token
#define pushStatTok()\
{\
    if (++pmStkP < PmStkMax) {\
	parsStk[pmStkP] = currstat;\
	MOVETOKEN;\
    } else {\
	token->code = voc[token->code-TermMin].scc;\
	paAbort(token, OFLW_ERR, SYS_SEV);\
    }\
} 

#define pushStat()\
{\
    if (++pmStkP < PmStkMax) {\
	parsStk[pmStkP] = currstat;\
    } else {\
	token->code = voc[token->code-TermMin].scc;\
	paAbort(token, OFLW_ERR, SYS_SEV);\
    }\
} 



/*----------------------------------------------------------------------------
 * actTbl - Do a look-up in the action table
 *----------------------------------------------------------------------------
 */
#define actTbl(st, sy, action, arg)\
{\
    register int actEnt;\
    register int actSt;\
    register int actSy;\
    actSt = st - StateMin;\
    actSy = sy - TermMin;\
    if (act.actCheck[act.actRix[actSt] + actSy] == actSt)\
	actEnt = act.act[act.actRix[actSt] + actSy];\
    else actEnt = ERROR_ACT;\
    *action = actEnt & 0x7;\
    *arg = actEnt >> 3;\
}/*actTbl()*/


/*----------------------------------------------------------------------------
 * gtoTbl - Do a look-up in the goto table
 *----------------------------------------------------------------------------
 */
#define gtoTbl(st, sy, action, arg)\
{\
    register int gtoEnt;\
    register int gtoSt;\
    register int gtoSy;\
    gtoSt = st - StateMin;\
    gtoSy = sy - Terms - 1;\
	gtoEnt = gto.gto[gto.gtoRix[gtoSt] + gtoSy];\
    *action = gtoEnt & 0x7;\
    *arg = gtoEnt >> 3;\
}/*gtoTbl()*/


/*----------------------------------------------------------------------------
 * E R R O R   R E C O V E R Y
 * ---------------------------
 *
 * The error recovery algorithm tries to modify current configuration in such
 * a way that parsing can be resumed correctly. Current configuration is
 * characterized by:
 *
 * w = x t y, where  x = parsed input
 *		     t = current token
 *		     y = unprocessed input
 *----------------------------------------------------------------------------
 */

typedef struct {
    Token err_tok;
    Token res_tok;
    short method;
    short eClass;
    short severity;
} ERR_REC;

static ERR_REC errdescr; 


/*----------------------------------------------------------------------------
 * ePush - Push a state during error recovery
 *----------------------------------------------------------------------------
 */
static void ePush(
UByte2 state,			/* IN state to push */
UByte2 stack[],			/* INOUT parser stack */
short *sp			/* INOUT current stack pointer */
)
{
    if (++(*sp) < PmStkMax) stack[*sp] = state;
    else paAbort(&errdescr.err_tok, OFLW_ERR, SYS_SEV);
}/*ePush()*/


/*----------------------------------------------------------------------------
 * legalAct - Check if a symbol is legal to shift in current state
 *----------------------------------------------------------------------------
 */
static PmBoolean legalAct(
UByte2 stack[],			/* IN current stack */
short stack_p,			/* IN current stack pointer */
UByte1 sym			/* IN symbol code */
)				/* RET true if "symbol" is read (shifted) */
				/*     in current state */
{
    UByte2 state;		/* Current state */
    UByte1 action;		/* Current parser action */
    UByte2 arg;			/* Current parser argument */

    ParseStack t_stk;		/* Temporary parser stack */
    int i;			/* For loop index */

    /* Copy stack
     */
    for (i = 0; i <= stack_p; i++) t_stk[i] = stack[i]; 

    state = stack[stack_p];

    for (;;) {
	actTbl(state, sym, &action, &arg);
	switch (action) {

	case ERROR_ACT:
	    return(PMFALSE);

	case SHIFT_ACT:
	case SHIFTRED_ACT:	
	case ACCEPT_ACT:
	    return(PMTRUE);

	case REDUCE_ACT:
	    do {
		stack_p = stack_p - gto.rhsz[arg - ProdMin];
		gtoTbl(t_stk[stack_p], gto.lhs[arg - ProdMin], &action, &arg);
		ePush(state, t_stk, &stack_p);
	    } while (action != SHIFT_ACT);
	    state = arg; t_stk[stack_p] = state;
	    break;

	}/*switch*/
    }/*for*/
}/*legalAct()*/
			     
	
/*----------------------------------------------------------------------------
 * gLegSym - Get legal symbols
 *----------------------------------------------------------------------------
 */
static void gLegSym(
ParseStack stack,		/* IN current stack */
short stack_p,			/* IN current stack pointer */
TermSet legals			/* OUT legal symbols in current state */
)
{
    short sym;			/* Loop index */

    SetClear(legals, Terms + 1);
    for (sym = 1; sym <= Terms; sym++) {
	if (legalAct(stack, stack_p, sym)) SetIns(legals, sym);
    }/*for*/
}/*gLegSym()*/


/*----------------------------------------------------------------------------
 * backup - Backup the parse stack until current symbol is accepted (shifted)
 *	    or the parse stack becomes empty
 *----------------------------------------------------------------------------
 */
static short backup(
ParseStack stack,		/* IN current stack */
short stack_p,			/* IN current stack pointer */
UByte1 sym	/* IN recovery symbol */
)				/* RET new stack pointer, 0 if symbol is */
				/*     not accepted */
{
    while ((stack_p > 0) && (!legalAct(stack, stack_p, sym))) stack_p--;
    return(stack_p);
}/*backup()*/


/*----------------------------------------------------------------------------
 * delSym - Delete a symbol in the input stream
 *----------------------------------------------------------------------------
 */
static void delSym(
Token *token			/* INOUT symbol to delete, new symbol */
)
{
    short  t;

    t = token->code - TermMin;
    token->code = voc[t].scc;
    pmDSym(token, voc[t].name, voc[t].psym);
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
    if (errdescr.method == IN_REC) errdescr.method = REP_REC;
    else if (errdescr.method != REP_REC) errdescr.method = DEL_REC;
}/*delSym()*/


/*----------------------------------------------------------------------------
 * inSym - Insert a symbol in the input stream
 *----------------------------------------------------------------------------
 */
static void inSym(
short isym,			/* IN symbol code to insert */
Token *gen_symb		/* OUT created symbol */
)
{
    pmISym(voc[isym - TermMin].scc, voc[isym - TermMin].name,
	   voc[isym - TermMin].psym, gen_symb);
    if (errdescr.method == DEL_REC) errdescr.method = REP_REC;
    else if (errdescr.method != REP_REC) errdescr.method = IN_REC; 

    gen_symb->code = isym;
}/*inSym()*/


/*----------------------------------------------------------------------------
 * M U L T I P L E   R E C O V E R Y
 * ---------------------------------
 *
 * The multiple symbols recovery technique is a "true local corrector", i.e.
 * it will always return a legal configuration for any input. Logically the
 * algorithm can be described as follows:
 *
 * 1) Roerich method (Karlsruhe):
 *    a. Find a continuation "u" of "x", such that "xu" is accepted.
 *    b. De composite "ty" into "qsy'", where q is a string.
 *    c. Delete "q".
 *    d. Insert u' (a prefix of u) between "x" and "sy'" giving xu' s y'.
 *
 * 2) Panic mode:
 *    If "q" contains a fiducial symbol "a"  then:
 *    a. Pop stack until "a" is accepted.
 *    b. If not succeeded resume at step 1.
 *----------------------------------------------------------------------------
 */

typedef struct {
    UByte2 r_state;		/* Recovery state */
    PmBoolean r_sepa;		/* Insert separator? */
    UByte2 r_sstat;		/* Where to insert separator */
} REC_POI;


/*----------------------------------------------------------------------------
 * acceptbl - Check whether "symbol" is reachable from current state using
 *	      the continuation grammar.
 *----------------------------------------------------------------------------
 */
static void acceptbl(
UByte1 sym,			/* IN terminal symbol code */
ParseStack stack,		/* IN parse stack */
short stack_p,			/* IN stack pointer */
Token *token,			/* IN current token */
PmBoolean *found,		/* OUT "symbol" accepted? */
REC_POI *point			/* OUT recovery point description */
)
{
    PmBoolean done;		/* Terminator flag */
    UByte2 state;		/* Current state */
    UByte1 action;		/* Parser action */
    UByte1 sep_act;		/* Parser action separator test */
    UByte2 arg;			/* Parser prod/state */
    UByte2 sep_arg;		/* Parser prod/state separator test */
    PmBoolean sepa_acc;		/* Separator is accepted? */
    ParseStack t_stk;		/* Temporary parser stack */
    short i;			/* Copy loop index */

    for (i = 0; i <= stack_p; i++) t_stk[i] = stack[i];

    state = t_stk[stack_p];
    done = PMFALSE;

    while (!done) {
	actTbl(state, sym, &action, &arg);
	if (legalAct(t_stk, stack_p, sym)) {
	    /* Symbol is directly accepted */
	    done = PMTRUE;
	    *found = PMTRUE;
	    point->r_state = state;
	} else {
	    /* Use the continuation grammar */
	    actTbl(state, act.recover.cont[state - StateMin].tsym, &action,
		   &arg);
	    actTbl(state, act.recover.cont[state - StateMin].ssym, &sep_act,
		   &sep_arg);
	    if ((action != sep_act) || (arg != sep_arg)) {
		/* A separator is legal. Check if current symbol is accepted
		 * behind the separator
		 */
	        ParseStack stk;	/* Temporary stack */
	        short sp;	/* Temporary stack pointer */

		sp = stack_p; 
		for (i = 0; i <= stack_p; i++) stk[i] = t_stk[i];
		sepa_acc = PMFALSE;

		while (!sepa_acc) {
		  actTbl(stk[sp], act.recover.cont[state - StateMin].ssym,
			 &sep_act, &sep_arg);
		    switch (sep_act) {

		    case ERROR_ACT:
		    case ACCEPT_ACT:
			sepa_acc = PMTRUE;
			break;

		    case SHIFT_ACT: 
			sepa_acc = PMTRUE;
			ePush(sep_arg, stk, &sp);
			break;

		    case SHIFTRED_ACT:
			ePush(1, stk, &sp);
			sepa_acc = PMTRUE;
			goto reduce;

		    case REDUCE_ACT:
		      reduce:
			do {
			    sp -= gto.rhsz[sep_arg-ProdMin];
			    gtoTbl(stk[sp], gto.lhs[sep_arg-ProdMin], &sep_act,
				   &sep_arg);
			    ePush(1, stk, &sp);
			} while (sep_act != SHIFT_ACT);

			stk[sp] = sep_arg;
			break;
		    }/*switch*/
		}/*while*/

		if ((sep_act == SHIFT_ACT) || (sep_act == SHIFTRED_ACT)) {
		    if (legalAct(stk, sp, sym)) {
			/* Separator is to be inserted */
			point->r_state = stk[sp];
			point->r_sepa = PMTRUE;
			point->r_sstat = state;
			done = PMTRUE;
			*found = PMTRUE;
		    }/*if*/
		}/*if*/
	    }/*if*/
		  
	    if (!*found) {
		switch (action) {

		case ERROR_ACT: 
		    paAbort(token, TAB_ERR, SYS_SEV);
		    break;

		case ACCEPT_ACT:
		    done = PMTRUE;
		    break;

		case SHIFT_ACT:
		    state = arg;
		    ePush(state, t_stk, &stack_p);
		    break;

		case SHIFTRED_ACT:
		    ePush(state, t_stk, &stack_p);
		    goto reduce2;

		case REDUCE_ACT:
		  reduce2:
		    do {
			stack_p -= gto.rhsz[arg-ProdMin];
			gtoTbl(t_stk[stack_p], gto.lhs[arg-ProdMin], &action,
			       &arg);
			ePush(state, t_stk, &stack_p);
		    } while (action != SHIFT_ACT);

		    state = arg;
		    t_stk[stack_p] = state;
		    break;

		}/*switch*/
	    }/*if*/
	}/*if*/
    }/*while*/
}/*acceptbl()*/


/*----------------------------------------------------------------------------
 * search - Search recovery point
 *----------------------------------------------------------------------------
 */
static void search(
ParseStack stack,		/* IN current stack */
short *stack_p,			/* INOUT current stack pointer */
Token *token,			/* INOUT current symbol */
REC_POI *point			/* OUT descriptor of where to restart */
				/*     the parser */
)
{
    UByte2 state;		/* Current state */
    PmBoolean rp_found;		/* Recovery point found? */
    short new_stkp;		/* Temp stack pointer */

    state = stack[*stack_p];
    point->r_state = state;
    point->r_sepa = PMFALSE;
    point->r_sstat = 1;
    rp_found = PMFALSE;

    do {
	if (!SetMem(act.recover.skip, token->code)) {
	    acceptbl(token->code, stack, *stack_p, token, &rp_found, point);
	}/*if*/

	if (!rp_found) {
	    new_stkp = 0;
	    if (SetMem(act.recover.fiduc, token->code)) {
		new_stkp = backup(stack, *stack_p, token->code);
	    }/*if*/
	    if (new_stkp > 0) {
		rp_found = PMTRUE;
		*stack_p = new_stkp;
		point->r_state = stack[*stack_p];
		errdescr.method = BAK_REC;
	    } else 
	        delSym(token);
	}/*if*/
    } while (!rp_found);
}/*search()*/


/*----------------------------------------------------------------------------
 * reach - Use the continuation functions and insert symbols upto curr token.
 *----------------------------------------------------------------------------
 */
static void reach(
ParseStack stack,		/* INOUT current stack */
short *stack_p,			/* INOUT current stack pointer */	
Token *token,			/* INOUT current symbol */
REC_POI *point			/* IN recovery point descriptor */
)
{
    UByte2 state;		/* Current state */
    UByte1 cont_sym;		/* Continuation symbol */
    Token gen_symb;		/* Generated symbol */
    UByte1 action;		/* Current parser action */
    UByte2 arg;			/* Current prod/state */
    PmBoolean sepaAccept;	/* Separator accepted yet? */
    PmBoolean useSepa;		/* Use the separator now? */

    state = stack[*stack_p];
    gen_symb = *token;
    useSepa = PMFALSE;
    while (state != point->r_state) {
	if (point->r_sepa)
	    if (state == point->r_sstat) {
		/* Separator state reached, remember to use separator */
		cont_sym = act.recover.cont[state-StateMin].ssym;
		useSepa = PMTRUE;
	    } else cont_sym = act.recover.cont[state-StateMin].tsym;
	else cont_sym = act.recover.cont[state-StateMin].tsym;
	sepaAccept = PMFALSE;

	do {
	  actTbl(state, cont_sym, &action, &arg);
	  switch (action) {

	  case ERROR_ACT:
	    paAbort(token, TAB_ERR, SYS_SEV);
	    break;

	  case ACCEPT_ACT:
	    break;

	  case SHIFT_ACT:
	    sepaAccept = PMTRUE;
	    state = arg;
	    inSym(cont_sym, &gen_symb);
	    ePush(state, stack, stack_p);
	    pmSySt[*stack_p] = gen_symb;
	    break;

	  case SHIFTRED_ACT:
	    sepaAccept = PMTRUE;
	    inSym(cont_sym, &gen_symb);
	    ePush(state, stack, stack_p);
	    pmSySt[*stack_p] = gen_symb;
	    goto reduce;

	  case REDUCE_ACT:
	    reduce:
	    do {
		*stack_p = *stack_p - gto.rhsz[arg-ProdMin];
		pmPaSema(arg);
		gtoTbl(stack[*stack_p], gto.lhs[arg-ProdMin], &action, &arg);
		ePush(state, stack, stack_p);
	    } while (action != SHIFT_ACT);
	    state = arg;
	    stack[*stack_p] = state;
	  }/*switch*/
	} while (useSepa && !sepaAccept);
    }/*while*/
}/*reach()*/


/*----------------------------------------------------------------------------
 * global - Global error recovery
 *----------------------------------------------------------------------------
 */
static void multiple(
ParseStack err_stk,		/* INOUT current parse stack */
short *err_stkp,		/* INOUT current stack pointer */
Token *err_tok,		/* INOUT current token */
UByte2 *newstat		/* OUT state after recovery */	
)
{
    REC_POI  point;		/* Recovery point descriptor */

    search(err_stk, err_stkp, err_tok, &point);
    reach(err_stk, err_stkp, err_tok, &point);
    *newstat = err_stk[*err_stkp];
}/*multiple()*/


/*----------------------------------------------------------------------------
 * S I N G L E   R E C O V E R Y
 * -----------------------------
 *
 * The single recovery technique tries to REPAIR the error by finding the
 * least cost single symbol correction. One single symbol of:
 * - insertion
 * - deletion
 * - replacement
 * is concidered. The cost of the repair is the sum of the ADAPTION cost and
 * the MODIFICATION cost. The adaption cost indicates how well a correction
 * fits in the context. The modification cost is based on the
 * insertion/deletion cost given in the input. A correction is applied if
 * the cost is below a predefined threshold value.
 *----------------------------------------------------------------------------
 */

#define ShiftCost (PmCost)	/* The cost of shifting one symbol */
#define InfCost (ShiftCost * (PmLaMax)) /* Infinity */
#define Thresh (((PmLaMax) - 3) * ShiftCost) /* Acceptance cost */


/*----------------------------------------------------------------------------
 * readLa - Read tokens to the look-ahead buffer
 *----------------------------------------------------------------------------
 */
static void readLa(
Token *curtok			/* IN current token */
)
{
    int i;
    Token tokbuf;
    Token *token = &tokbuf;

    la_buff[0] = *curtok;
    *token = *curtok;
    for (i = la_ptr + 1; i <= la_end; i++) {
	/* Move old look_ahead to the beginning of the buffer */
	la_buff[i - la_ptr] = la_buff[i];
    }/*for*/
    la_end = la_end - la_ptr;
    la_ptr = -1;

    while ((la_buff[la_end].code != ENDMARK) && (la_end < PmLaMax)) {
	la_end++;
	do {
            

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else {
		token->code = scIndex[token->code];
	    }/*if*/
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
	    }/*if*/
	} while (token->code == ERR_SYM);
	la_buff[la_end] = *token;
    }/*while*/
}/*readLa()*/


/*----------------------------------------------------------------------------
 * rdLaSym - Fetches the i:th look-ahead symbol code from the look-ahead set
 *----------------------------------------------------------------------------
 */
static UByte1 rdLaSym(
char index			/* IN i:th look-ahead symbol */
)				/* RET token code */
{
    if (index > la_end) return(ENDMARK);
    else return(la_buff[(int)index].code);
}/*rdLaSym()*/


/*----------------------------------------------------------------------------
 * laParse - Continue the parsing process by reading tokens from the
 *	     look-ahead set. The parse is terminated when:
 *	     - out of read ahead
 *	     - a new error is encountered
 *	     Note! No semantic actions are carried out
 *----------------------------------------------------------------------------
 */
static void laParse(
UByte1 sym,			/* IN current terminal symbol */
char next_la,			/* IN index to next look-ahead symbol */
ParseStack stack,		/* IN parse stack */
short stack_p,			/* IN current stack pointer */
short *cost			/* OUT adaption cost */
)
{
    PmBoolean done ;		/* Terminator flag */
    char sh_cnt;		/* Number of shifted symbols */
    UByte2 state;		/* Current state number */
    UByte1 action;		/* Parser action */
    UByte2 arg; 		/* Parser argument */
    short i;			/* Loop index */
    ParseStack t_stk;		/* Temporary stack */

    /* Copy stack
     */
    for (i = 0; i <= stack_p; i++) t_stk[i] = stack[i];	

    done = PMFALSE;
    sh_cnt = 0;
    state = t_stk[stack_p];

    while (!done) {
	actTbl(state, sym, &action, &arg);
	
	switch (action) {

	case ERROR_ACT: 
	    done = PMTRUE;
	    break;

	case SHIFT_ACT:
	    state = arg;
	    ePush(state, t_stk, &stack_p);
	    sh_cnt++;
	    if (sh_cnt == PmLaMax) done = PMTRUE;
	    else {
		sym = rdLaSym(next_la);
		next_la++;
	    }/*if*/
	    break;

	case SHIFTRED_ACT:
	    ePush(state, t_stk, &stack_p);
	    sh_cnt++;
	    if (sh_cnt == PmLaMax) done = PMTRUE;
	    else {
		sym = rdLaSym(next_la);
		if (next_la < PmLaMax) next_la++;
	    }/*if*/
	    goto reduce;

	case REDUCE_ACT:
	  reduce:
	    do {
		stack_p -= gto.rhsz[arg-ProdMin];
		gtoTbl(t_stk[stack_p], gto.lhs[arg-ProdMin], &action, &arg);
		ePush(state, t_stk, &stack_p);
	    } while (action != SHIFT_ACT); 

	    state = arg;
	    t_stk[stack_p] = state;
	    break;

	case ACCEPT_ACT:
	    done = PMTRUE;
	    sh_cnt = PmLaMax;
	    break;

	}/*switch*/
    }/*while*/

    *cost = InfCost - (sh_cnt*ShiftCost);
}/*laParse()*/


/*----------------------------------------------------------------------------
 * tryIn - Tries to insert a symbol from the legal set in front of current
 *	   token: x t y  => x st y, where s becomes current symbol
 *----------------------------------------------------------------------------
 */
static void tryIn(
TermSet legals,			/* IN set of legal symbols */
ParseStack stack,		/* IN current parser stack */
short stack_p,			/* IN current stack pointer */
UByte1 *sym,			/* OUT best insertion symbol */
short *cost,			/* OUT best cost so far */
short *choice			/* OUT best choice so far */
)
{
    short i;
    short mod_cost;		/* Modification cost */
    short ad_cost;		/* Adaption cost */
    short tot_cost;		/* Total insertion cost */

    for (i = 1; i <= Terms; i++) {
	/* For all legal symbols
	 */
	if (SetMem(legals, i)) {
	    mod_cost = voc[i - TermMin].iCost;
	    if (mod_cost < *cost) {
		laParse(i, 0, stack, stack_p, &ad_cost);
		tot_cost = ad_cost + mod_cost;
		if (tot_cost < *cost) {
		    *cost = tot_cost;
		    *choice = IN_REC;
		    *sym = (UByte1)i;
		}/*if*/
	    }/*if*/
	}/*if*/
    }/*for*/
}/*tryIn()*/


/*----------------------------------------------------------------------------
 * tryRep - Tries to replace currrent symbol with a new terminal:
 *	    x t y  => x s y, where s becomes current symbol
 *----------------------------------------------------------------------------
 */
static void tryRep(
TermSet legals,			/* IN set of legal symbols */
ParseStack stack,		/* IN current parser stack */
short stack_p,			/* IN current stack pointer */
UByte1 *sym,			/* OUT best replacement symbol */
short *cost,			/* OUT best cost so far */
short *choice			/* OUT best choice so far */
)
{
    short i;
    short mod_cost;		/* Modification cost */
    short ad_cost;		/* Adaption cost */
    short tot_cost;		/* Total replacment cost */

    for (i = 1; i <= Terms; i++) {
	/* For all legal symbols
	 */
	if (SetMem(legals, i)) {
	    mod_cost = (short) (voc[i-TermMin].iCost +
			voc[rdLaSym(0)-TermMin].dCost) / 2 + 1;
	    if (mod_cost < *cost) {
		laParse(i, 1, stack, stack_p, &ad_cost);
		tot_cost = ad_cost + mod_cost;
		if (tot_cost < *cost) {
		    *cost = tot_cost;
		    *choice = REP_REC;
		    *sym = (UByte1)i;
		}/*if*/
	    }/*if*/
	}/*if*/
    }/*for*/
}/*tryRep()*/


/*----------------------------------------------------------------------------
 * tryDel - Tries to delete current symbol: x t y  => x y
 *----------------------------------------------------------------------------
 */
static void tryDel(
ParseStack stack,		/* IN current parser stack */
short stack_p,			/* IN current stack pointer */
short *cost,			/* INOUT best cost so far */
short *choice			/* INOUT best choice so far */
)
{
    short mod_cost;		/* Modification cost */
    short ad_cost;  		/* Adaption cost */
    short tot_cost;		/* Total deletion cost */

    mod_cost = voc[rdLaSym(0) - TermMin].dCost;
    if (mod_cost < *cost) {
	laParse(rdLaSym(1), 2, stack, stack_p, &ad_cost);
	tot_cost = ad_cost + mod_cost;
	if (tot_cost < *cost) {
	    *cost = tot_cost;
	    *choice = DEL_REC;
	}/*if*/
    }/*if*/
}/*tryDel()*/


/*----------------------------------------------------------------------------
 * _pmInsert
 *----------------------------------------------------------------------------
 */
static void _pmInsert(
UByte1 sym,			/* IN symbol code to insert */
Token *token			/* OUT constructed token */
)
{
    inSym(sym, token);
}/*_pmInsert()*/


/*----------------------------------------------------------------------------
 * _pmReplace
 *----------------------------------------------------------------------------
 */
static void _pmReplace(
UByte1 sym,			/* IN replacement symbol code */
Token *token			/* OUT constructed token */
)
{
    delSym(token);
    inSym(sym, token);
}/*_pmReplace()*/


/*----------------------------------------------------------------------------
 * _pmDelete
 *----------------------------------------------------------------------------
 */

static void _pmDelete(
Token *token			/* OUT new token */
)
{
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
    delSym(token);
}/*_pmDelete()*/


/*----------------------------------------------------------------------------
 * single - Single error recovery
 *----------------------------------------------------------------------------
 */
static void single(
TermSet leg_sys,		/* IN legal symbols in current state */
ParseStack err_stk,		/* INOUT current parser stack */
short *err_stkp,		/* INOUT current stack pointer */
Token *token,		/* INOUT current token */
UByte2 *newstat		/* OUT recovery state */
)
{
    short choice;		/* Recovery action performed */
    short cost;			/* Best cost so far */
    UByte1 sym;			/* Insert symbol */

    choice = NONE_REC;
    cost = InfCost;
    readLa(token);

    tryIn(leg_sys, err_stk, *err_stkp, &sym, &cost, &choice);
    tryRep(leg_sys, err_stk, *err_stkp, &sym, &cost, &choice);
    tryDel(err_stk, *err_stkp, &cost, &choice);

    if (cost > Thresh) choice = NONE_REC;

    switch (choice) {

    case IN_REC:
	_pmInsert(sym, token);
	break;

    case DEL_REC:  
	_pmDelete(token);
	break;

    case REP_REC: 
	_pmReplace(sym, token);
	break;

    default:
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
    }/*switch*/

    *newstat = err_stk[*err_stkp];
}/*single()*/



/*----------------------------------------------------------------------------
 * recover - From an error
 *----------------------------------------------------------------------------
 */
static void recover(
ParseStack err_stk,		/* INOUT updated parse stack */
short *err_stkp,		/* INOUT updated stack pointer */
Token *err_symb,		/* INOUT current token */
UByte2 *rec_stat		/* OUT state after recovery */
)
{
    TermSet legal_sy;		/* Legal symbols */

    errdescr.err_tok = *err_symb;
    errdescr.err_tok.code = voc[errdescr.err_tok.code - TermMin].scc;
    errdescr.method = NONE_REC;
    errdescr.eClass = SYN_ERR;
    errdescr.severity = ERR_SEV;
    gLegSym(err_stk, *err_stkp, legal_sy);
    single(legal_sy, err_stk, err_stkp, err_symb, rec_stat);
    if (errdescr.method == NONE_REC) {
	multiple(err_stk, err_stkp, err_symb, rec_stat);
	pmMess(&errdescr.err_tok, errdescr.method, errdescr.eClass, 
	       errdescr.severity); 
    } else {
	pmMess(&errdescr.err_tok, errdescr.method, SYN_ERR, errdescr.severity);
    }/*if*/
    errdescr.res_tok = *err_symb;
    errdescr.res_tok.code = voc[errdescr.res_tok.code - TermMin].scc;
    pmRPoi(&errdescr.res_tok);
}/*recover()*/


/*----------------------------------------------------------------------------
 * pmParse - Parser routine, entry point
 *----------------------------------------------------------------------------
 */
void pmParse(void)
{
    paInit();
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
    pushStatTok()
    if (setjmp(pmJmpB)) return;

    while (!endparse) {
	actTbl(currstat, token->code, &action, &arg);

	switch (action) {

	case ERROR_ACT:
	    recover(parsStk, &pmStkP, token, &currstat);
	    if (pmStkP == 0) endparse = PMTRUE;
	    break;

	case SHIFT_ACT:
	    currstat = arg;
	    pushStatTok();
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
	    break;

	case SHIFTRED_ACT:
	    pushStatTok();
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
	    goto reduce;

 	case REDUCE_ACT:
	  reduce:
	    do {
		pmStkP -= gto.rhsz[arg - ProdMin];	
		pmPaSema(arg);
		gtoTbl(parsStk[pmStkP], gto.lhs[arg - ProdMin], &action, &arg);
		pushStat();
	    } while (action != SHIFT_ACT);

	    currstat = arg;
	    parsStk[pmStkP] = currstat;
	    break;

	case ACCEPT_ACT:
	    endparse = PMTRUE;
	    break;
	}/*switch*/
    }/*while*/
}/*pmParse()*/

